package org.mut.ampa.client;


import org.mut.ampa.client.screens.login.LoginService;
import org.mut.ampa.client.screens.login.LoginServiceAsync;
import org.mut.ampa.client.screens.manteniment.MantenimentService;
import org.mut.ampa.client.screens.manteniment.MantenimentServiceAsync;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Punt d'entrada de l'aplicació GWT. 
 * Crea els objectes d'acces als serveis remots de Login i Manteniment.
 * Inicia l'aplicació carregant el controlador principal de l'aplicació
 * @author Mario Unio UOC 2012
 *
 */
public class AmpaEntryPoint implements EntryPoint {

	@Override
	public void onModuleLoad() {
		
		//Servei Remot
	 	LoginServiceAsync rpcService = GWT.create(LoginService.class);
	 	MantenimentServiceAsync rpcMantenimentService = GWT.create(MantenimentService.class);
	 	
	 	//Bus d'events
	    HandlerManager eventBus = new HandlerManager(null);
	    
	    //Controlador principal aplicació
	    AppController appViewer = new AppController(rpcService, rpcMantenimentService,eventBus);
	    appViewer.go(RootPanel.get());
	}

}
