package org.mut.ampa.client;

import org.mut.ampa.client.screens.error.event.ErrorAmpaEvent;
import org.mut.ampa.client.screens.error.event.ErrorAmpaEventHandler;
import org.mut.ampa.client.screens.error.presenter.ErrorScreenPresenter;
import org.mut.ampa.client.screens.error.view.ErrorScreen;
import org.mut.ampa.client.screens.login.LoginServiceAsync;
import org.mut.ampa.client.screens.login.event.ValidateUserEvent;
import org.mut.ampa.client.screens.login.event.ValidateUserEventHandler;
import org.mut.ampa.client.screens.login.presenter.LoginPresenter;
import org.mut.ampa.client.screens.login.view.LoginView;
import org.mut.ampa.client.screens.main.event.LogoutUserEvent;
import org.mut.ampa.client.screens.main.event.LogoutUserEventHandler;
import org.mut.ampa.client.screens.main.presenter.MainAppPresenter;
import org.mut.ampa.client.screens.main.view.MainAppView;
import org.mut.ampa.client.screens.manteniment.MantenimentServiceAsync;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneCancelledEvent;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneCancelledEventHandler;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneEvent;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneEventHandler;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneUpdateEvent;
import org.mut.ampa.client.screens.manteniment.alumne.event.EditAlumneUpdateEventHandler;
import org.mut.ampa.client.screens.manteniment.alumne.presenter.AlumneEditPresenter;
import org.mut.ampa.client.screens.manteniment.alumne.presenter.AlumneListPresenter;
import org.mut.ampa.client.screens.manteniment.alumne.view.AlumneEditView;
import org.mut.ampa.client.screens.manteniment.alumne.view.AlumneListEdit;
import org.mut.ampa.client.screens.manteniment.associacio.presenter.AssociacioEditPresenter;
import org.mut.ampa.client.screens.manteniment.associacio.view.AssociacioEditView;
import org.mut.ampa.client.screens.manteniment.contracte.presenter.ContractarPresenter;
import org.mut.ampa.client.screens.manteniment.contracte.view.ContractarView;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursCancelledEvent;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursCancelledEventHandler;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursEvent;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursEventHandler;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursUpdateEvent;
import org.mut.ampa.client.screens.manteniment.curs.event.EditCursUpdateEventHandler;
import org.mut.ampa.client.screens.manteniment.curs.presenter.CursEditPresenter;
import org.mut.ampa.client.screens.manteniment.curs.presenter.CursListPresenter;
import org.mut.ampa.client.screens.manteniment.curs.view.CursEditView;
import org.mut.ampa.client.screens.manteniment.curs.view.CursListEdit;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupCancelledEvent;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupCancelledEventHandler;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupEvent;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupEventHandler;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupUpdateEvent;
import org.mut.ampa.client.screens.manteniment.grup.event.EditGrupUpdateEventHandler;
import org.mut.ampa.client.screens.manteniment.grup.presenter.GrupEditPresenter;
import org.mut.ampa.client.screens.manteniment.grup.presenter.GrupListPresenter;
import org.mut.ampa.client.screens.manteniment.grup.view.GrupEditView;
import org.mut.ampa.client.screens.manteniment.grup.view.GrupListEdit;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorCancelledEvent;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorCancelledEventHandler;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorEvent;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorEventHandler;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorUpdateEvent;
import org.mut.ampa.client.screens.manteniment.tutor.event.EditTutorUpdateEventHandler;
import org.mut.ampa.client.screens.manteniment.tutor.presenter.TutorEditPresenter;
import org.mut.ampa.client.screens.manteniment.tutor.presenter.TutorListPresenter;
import org.mut.ampa.client.screens.manteniment.tutor.view.TutorEditView;
import org.mut.ampa.client.screens.manteniment.tutor.view.TutorListEdit;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariCancelledEvent;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariCancelledEventHandler;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariEvent;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariEventHandler;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariUpdateEvent;
import org.mut.ampa.client.screens.manteniment.usuari.event.EditUsuariUpdateEventHandler;
import org.mut.ampa.client.screens.manteniment.usuari.presenter.UsuariEditPresenter;
import org.mut.ampa.client.screens.manteniment.usuari.presenter.UsuariListPresenter;
import org.mut.ampa.client.screens.manteniment.usuari.view.UsuariEditView;
import org.mut.ampa.client.screens.manteniment.usuari.view.UsuariListEdit;
import org.mut.ampa.client.widget.menu.event.ManagementUserEvent;
import org.mut.ampa.client.widget.menu.event.ManagementUserEventHandler;
import org.mut.ampa.client.widget.messagebox.MessageBox;
import org.mut.ampa.client.widget.messagebox.MessageBox.MessageBoxType;
import org.mut.ampa.shared.LoginCredential;
import org.mut.ampa.shared.model.AlumneBrief;
import org.mut.ampa.shared.model.Curs;
import org.mut.ampa.shared.model.CursGrupInfo;
import org.mut.ampa.shared.model.Tutor;
import org.mut.ampa.shared.model.Usuari;

import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.History;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Frame;
import com.google.gwt.user.client.ui.HasWidgets;

/**
 * Controlador Principal de l'aplicació
 * Gestiona el Bus d'events realitzant la navegació entre les diferents pantalles de l'aplicació
 * 
 * @author Mario Unio UOC 2012
 *
 */
public class AppController implements ValueChangeHandler<String>{

	private LoginServiceAsync rpcService;
	private MantenimentServiceAsync rpcMantenimentService;
	private HandlerManager     eventBus;
	private HasWidgets         mainContainer;
	private HasWidgets         innerContainer=null;
	private LoginCredential credencial ;
	
	public AppController(LoginServiceAsync rpcService,
			             MantenimentServiceAsync rpcMantenimentService,
			             HandlerManager eventBus) {
		
		this.rpcService = rpcService;
		this.rpcMantenimentService = rpcMantenimentService;
		this.eventBus   = eventBus;
		bind();
		
	}
	
	private void bind() {
		
			//Registrem el App controlador al GWT.History per poder fer el seguiment de 
		    //les transicions entre pantalles de l'aplicació 
			//"estat de l'aplicació" 
			History.addValueChangeHandler(this);
		
			
		    eventBus.addHandler(ValidateUserEvent.TYPE,new ValidateUserEventHandler() {
				@Override
				public void onValidateUser(ValidateUserEvent event) {
					credencial = event.getCredential();
					login();
				}
		    });  
		    
		    eventBus.addHandler(LogoutUserEvent.TYPE, new LogoutUserEventHandler() {
				
				@Override
				public void onValidateUser(LogoutUserEvent event) {
					History.newItem(AppToken.TKN_LOGIN);
					
					
				}
			});
		    
		    eventBus.addHandler(ManagementUserEvent.TYPE, new ManagementUserEventHandler(){

				@Override
				public void onValidateUser(ManagementUserEvent event) {
					History.newItem(AppToken.TKN_MNT_USUARI);
					
				}});
		    
		    eventBus.addHandler(EditUsuariEvent.TYPE,   new EditUsuariEventHandler() {
		    	@Override
				public void onGoEditUsuari(EditUsuariEvent event) {
		    		History.newItem(AppToken.TKN_MNT_USUARI_EDIT, false);
		    		manteniment_usuari_edit(event.getUser(),event.getUpdateMode());
				}
	        });
		    
		    eventBus.addHandler(EditUsuariCancelledEvent.TYPE, new EditUsuariCancelledEventHandler() {
				
				@Override
				public void onEditUsuariCancelled(EditUsuariCancelledEvent event) {
					History.newItem(AppToken.TKN_MNT_USUARI);
					
				}
			});
		    
		    eventBus.addHandler(EditUsuariUpdateEvent.TYPE, new EditUsuariUpdateEventHandler() {

				@Override
				public void onEditUsuariUpdate(EditUsuariUpdateEvent event) {
					History.newItem(AppToken.TKN_MNT_USUARI);
				}
			});
		    
		    eventBus.addHandler(EditCursEvent.TYPE,   new EditCursEventHandler() {
		    	@Override
				public void onGoEditCurs(EditCursEvent event) {
		    		History.newItem(AppToken.TKN_MNT_CURS_EDIT, false);
		    		manteniment_curs_edit(event.getCurs(),event.getUpdateMode());
				}
	        });
		    
		    eventBus.addHandler(EditCursCancelledEvent.TYPE, new EditCursCancelledEventHandler() {
				
				@Override
				public void onEditCursCancelled(EditCursCancelledEvent event) {
					History.newItem(AppToken.TKN_MNT_CURS);
					
				}
			});
		    
		    eventBus.addHandler(EditCursUpdateEvent.TYPE, new EditCursUpdateEventHandler() {

				@Override
				public void onEditCursUpdate(EditCursUpdateEvent event) {
					History.newItem(AppToken.TKN_MNT_CURS);
				}
			});

		    
		    eventBus.addHandler(EditGrupEvent.TYPE,   new EditGrupEventHandler() {
		    	@Override
				public void onGoEditGrup(EditGrupEvent event) {
		    		History.newItem(AppToken.TKN_MNT_GRUP_EDIT, false);
		    		manteniment_grup_edit(event.getGrup(),event.getUpdateMode());
				}
	        });
		    
		    eventBus.addHandler(EditGrupCancelledEvent.TYPE, new EditGrupCancelledEventHandler() {
				
				@Override
				public void onEditGrupCancelled(EditGrupCancelledEvent event) {
					History.newItem(AppToken.TKN_MNT_GRUP);
					
				}
			});
		    
		    eventBus.addHandler(EditGrupUpdateEvent.TYPE, new EditGrupUpdateEventHandler() {

				@Override
				public void onEditGrupUpdate(EditGrupUpdateEvent event) {
					History.newItem(AppToken.TKN_MNT_GRUP);
				}
			});
		    
		    
		    eventBus.addHandler(EditTutorEvent.TYPE,   new EditTutorEventHandler() {
		    	@Override
				public void onGoEditTutor(EditTutorEvent event) {
		    		History.newItem(AppToken.TKN_MNT_TUTOR_EDIT, false);
		    		manteniment_tutor_edit(event.getTutor(),event.getUpdateMode());
				}


	        });
		    
		    eventBus.addHandler(EditTutorCancelledEvent.TYPE, new EditTutorCancelledEventHandler() {
				
				@Override
				public void onEditTutorCancelled(EditTutorCancelledEvent event) {
					History.newItem(AppToken.TKN_MNT_TUTOR);
					
				}
			});
		    
		    eventBus.addHandler(EditTutorUpdateEvent.TYPE, new EditTutorUpdateEventHandler() {

				@Override
				public void onEditTutorUpdate(EditTutorUpdateEvent event) {
					History.newItem(AppToken.TKN_MNT_TUTOR);
				}
			});
		    
		    
		    eventBus.addHandler(EditAlumneEvent.TYPE,   new EditAlumneEventHandler() {
		    	@Override
				public void onGoEditAlumne(EditAlumneEvent event) {
		    		History.newItem(AppToken.TKN_MNT_TUTOR_EDIT, false);
		    		manteniment_tutor_edit(event.getAlumne(),event.getUpdateMode());
				}




	        });
		    
		    eventBus.addHandler(EditAlumneCancelledEvent.TYPE, new EditAlumneCancelledEventHandler() {
				
				@Override
				public void onEditAlumneCancelled(EditAlumneCancelledEvent event) {
					History.newItem(AppToken.TKN_MNT_ALUMNE);
					
				}
			});
		    
		    eventBus.addHandler(EditAlumneUpdateEvent.TYPE, new EditAlumneUpdateEventHandler() {

				@Override
				public void onEditAlumneUpdate(EditAlumneUpdateEvent event) {
					History.newItem(AppToken.TKN_MNT_ALUMNE);
				}
			});
		    
		    
		    
		    
		    
		    
		    eventBus.addHandler(ErrorAmpaEvent.TYPE, new ErrorAmpaEventHandler() {

				@Override
				public void onErrorSucces(ErrorAmpaEvent event) {
								History.newItem(AppToken.TKN_ERROR,false);
								error_process(event.getMessage());
								
				}


			});
	}
	
	private void login() {
		 History.newItem(AppToken.TKN_LOGED);
		 
	}
	
	private void error_process(String message) {
		Presenter presenter = new ErrorScreenPresenter(eventBus, new ErrorScreen(), message);
	   	presenter.go(innerContainer);
		
	}
	
	private void manteniment_usuari_edit(Usuari user,boolean modeUpdate) 
	{
		Presenter presenter = new UsuariEditPresenter(credencial, 
				                                      rpcMantenimentService, 
				                                      eventBus,
				                                      new UsuariEditView(), 
				                                      user,modeUpdate); 
				
	   	presenter.go(innerContainer);
		
	}
	
	private void manteniment_curs_edit(Curs curs, boolean updateMode) {
		Presenter presenter = new CursEditPresenter(credencial, 
                rpcMantenimentService, 
                eventBus,
                new CursEditView(), 
                curs,updateMode); 

		presenter.go(innerContainer);
		
	}
	
	private void manteniment_grup_edit(CursGrupInfo grup, boolean updateMode) {
		Presenter presenter = new GrupEditPresenter(credencial, 
                rpcMantenimentService, 
                eventBus,
                new GrupEditView(), 
                grup,updateMode); 

		presenter.go(innerContainer);
		
	}
	
	private void manteniment_tutor_edit(Tutor tutor,boolean updateMode) {
		Presenter presenter = new TutorEditPresenter(credencial, 
                rpcMantenimentService, 
                eventBus,
                new TutorEditView(), 
                tutor,updateMode); 

		presenter.go(innerContainer);
		
	}
	private void manteniment_tutor_edit(AlumneBrief alumne,	boolean updateMode) {
		Presenter presenter = new AlumneEditPresenter(credencial, 
                rpcMantenimentService, 
                eventBus,
                new AlumneEditView(), 
                alumne,updateMode); 

		presenter.go(innerContainer);
		
	}
	
	
	@Override
	public void onValueChange(ValueChangeEvent<String> event) {
		
		String estat = event.getValue();
		if (estat != null)
		{
		  Presenter presenter = null;

		 
		
		 
		  
		   if (estat.equals(AppToken.TKN_LOGED))
		   {
		    	//nomes entrem si tenim una credencial  
		    	if(credencial!=null)
		    		{
		    		 //registrar credencial 
		    		rpcMantenimentService.registerCredential(credencial, new AsyncCallback<Void>() {
						
						@Override
						public void onSuccess(Void result) {
							//pasar el control al presentador de la pantalla principal
				    		Presenter presenter = new MainAppPresenter(eventBus,new MainAppView(credencial),credencial);
				    		 presenter.go(mainContainer);
				    		 innerContainer = ((MainAppPresenter)presenter).getInnerContainer();
						}
						
						@Override
						public void onFailure(Throwable caught) {
							History.newItem("login");
						}
					});
		    		
		    		 
		    		}
		    	
		   }
		   
		   if(estat.equals(AppToken.TKN_LOGIN))
		   {
		     //Resetegem la credencial en cas de mostrar pantalla login
		   	  credencial=null;
		   	  presenter = new LoginPresenter(rpcService, eventBus, new LoginView());
		   	  presenter.go(mainContainer);
		   } 

		   if(estat.equals(AppToken.TKN_MNT_USUARI))
		   {
				boolean[] visibleCols={true,true,true,true,true,true}; 
		   	   presenter = new UsuariListPresenter(credencial,rpcMantenimentService,eventBus,new UsuariListEdit(10, visibleCols,250,500));
		   	   presenter.go(innerContainer);
		   }
		   
		   if(estat.equals(AppToken.TKN_MNT_ASSOC_EDIT))
		   {
			   presenter = new AssociacioEditPresenter(credencial, rpcMantenimentService, eventBus, new AssociacioEditView());
		   	   presenter.go(innerContainer);
		   }
		   
		   
		   if(estat.equals(AppToken.TKN_MNT_CURS))
		   {
				boolean[] visibleCols={true,true}; 
		   	   presenter = new CursListPresenter(credencial,rpcMantenimentService,eventBus,new CursListEdit(10, visibleCols,250,500));
		   	   presenter.go(innerContainer);
		   }
		   
		   if(estat.equals(AppToken.TKN_MNT_GRUP))
		   {
				boolean[] visibleCols={true,true,true}; 
		   	   presenter = new GrupListPresenter(credencial,rpcMantenimentService,eventBus,new GrupListEdit(10, visibleCols,250,500));
		   	   presenter.go(innerContainer);
		   }
		   
		   if(estat.equals(AppToken.TKN_MNT_TUTOR))
		   {
				boolean[] visibleCols={true,true,true,true}; 
		   	   presenter = new TutorListPresenter(credencial,rpcMantenimentService,eventBus,new TutorListEdit(10, visibleCols,250,500));
		   	   presenter.go(innerContainer);
		   }
		   
		   
		   if(estat.equals(AppToken.TKN_MNT_ALUMNE))
		   {
			   boolean[] visibleCols={true,true,true,true,true}; 
		   	   presenter = new AlumneListPresenter(credencial,rpcMantenimentService,eventBus,new AlumneListEdit(10, visibleCols,250,500));
		   	   presenter.go(innerContainer);
		   }
		   
		   if(estat.equals(AppToken.TKN_CONTRACTAR))
		   {
			   presenter = new ContractarPresenter(credencial, rpcMantenimentService, eventBus, new ContractarView());
		   	   presenter.go(innerContainer);
		   }
		   
		   if(estat.equals(AppToken.TKN_UNDER_DEVELOP))
		   {
			   MessageBox msgBox = new MessageBox(MessageBoxType.INFORMATIU,"Opció pendent d'implementar"){

					@Override
					protected void onClickYes() {}

					@Override
					protected void onClickNo() {}

					@Override
					protected void onClickOK() {}
		    		
		    	};
		    	
		    	msgBox.show();
		   }
		   
		   if(estat.equals(AppToken.TKN_REPORT_ALUMNE1))
		   {
				rpcMantenimentService.getPdfReport(credencial, "reports/templates/alumnes1",null, new AsyncCallback<String>() 
			{
					
					@Override
					public void onSuccess(String result) {
						innerContainer.clear();
						Frame frame = new Frame(result);  
						frame.setSize("80%", "80%");
						frame.getElement().getStyle().setMargin(10, Unit.PX);
						frame.getElement().getStyle().setBackgroundColor("#FFF");
						// add the frame wherever you want
						innerContainer.add(frame);
									
					}
					
					@Override
					public void onFailure(Throwable caught) {
						// TODO Auto-generated method stub
						
					}
				});
		   }
		   
		   
		}
		
	}

	public void go(final HasWidgets container) {
	    

	    if ("".equals(History.getToken()))
	    {
	    	this.mainContainer = container;
	    	History.newItem("login");
	    }else{
	    	
	    	this.mainContainer = container;	
	    	History.fireCurrentHistoryState();
	    	
	    }
	  }

}
