package org.mut.ampa.client.screens.error.presenter;

import org.mut.ampa.client.Presenter;
import org.mut.ampa.client.screens.main.event.LogoutUserEvent;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.Widget;

public class ErrorScreenPresenter implements Presenter 
{
	public interface Display 
	{
		HasClickHandlers getOkButton();
		void setErrorMessage(String text);
		Widget asWidget();
	}
	
	private final HandlerManager eventBus;
	private final Display display;
	
	
	public ErrorScreenPresenter(HandlerManager eventBus,Display display,String errorMessage)
	{
		this.eventBus = eventBus;
		this.display = display;
		display.setErrorMessage(errorMessage);
		
		bind();
	}
	
	private void bind() {
		display.getOkButton().addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				eventBus.fireEvent(new LogoutUserEvent());
			}
		});
		
	}

	@Override
	public void go(HasWidgets container) {
		container.clear();
		container.add(display.asWidget());
			
	}

}
