package org.mut.ampa.client.screens.login.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.LayoutPanel;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Pantalla de login a Ampa la Rosella
 * @author mario UOC 2012
 *
 */
public class LoginView extends Composite implements org.mut.ampa.client.screens.login.presenter.LoginPresenter.Display
{
	
	private final LoginResources resources =  GWT.create(LoginResources.class);
	
	private final static String txtBotoEntrar="Entrar";
	private final static String txtLabelUsuari="Usuari";
	private final static String txtLabelPassword="Password";
	private final static String txtLabelBenvinguda="Identifiquis, si us plau";
	private final static String txtLabelTitol="Ampa la Rosella";
	
	    
	
		//Controls  
		private final LayoutPanel     root      = new LayoutPanel();
		private final VerticalPanel   box       = new VerticalPanel();
	    private final FlexTable       contenidorCamps= new FlexTable();
	    
	    private final Label titol = new Label(txtLabelTitol);
	    private final Label benvingudaLabel = new Label(txtLabelBenvinguda);
        private final TextBox nomField = new TextBox();
		private final PasswordTextBox passwordField = new PasswordTextBox();
		private final Label etiquetaError = new Label("");
		private Button loginButton = new Button(txtBotoEntrar);
	
		public LoginView() 
		{
			//inicialitzem objecte estils
			resources.style().ensureInjected();

			//iniciem Widget arrel
			initWidget(root);
					
			contenidorCamps.setCellSpacing(6);
			FlexCellFormatter cellFormatter = contenidorCamps.getFlexCellFormatter();
		   
			cellFormatter.setColSpan(0, 0, 2);
			cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

			contenidorCamps.setHTML(1, 0, txtLabelUsuari);
			
			//camp ID
			nomField.setEnabled(true);
			contenidorCamps.setWidget(1, 1, nomField);
				
			//camp Nom
			contenidorCamps.setHTML(2, 0, txtLabelPassword);
			contenidorCamps.setWidget(2, 1, passwordField);
			
			root.add(box);
			root.setWidgetLeftWidth(box, 35, Unit.PCT , 400, Unit.PX);
			root.setWidgetTopHeight(box, 50, Unit.PX ,250, Unit.PX);
			
			box.add(titol);
			box.add(benvingudaLabel);
			box.add(contenidorCamps);
			box.add(etiquetaError);
			box.add(loginButton);
			
			box.setStyleName(resources.style().loginBox());
			titol.setStyleName(resources.style().title());
			benvingudaLabel.setStyleName(resources.style().msgText());
			etiquetaError.setStyleName(resources.style().msgError());
			
		}

		@Override
		public HasClickHandlers getLoginButton() {
			return loginButton;
		}

		@Override
		public void setErrorMessage(String msg) {
			etiquetaError.setText(msg);
			
		}

		@Override
		public String getUserName() {
			
			return nomField.getValue();
		}

		@Override
		public String getUserPassword() {
			return passwordField.getValue();
		}
}
