package org.mut.ampa.client.screens.main.presenter;

import org.mut.ampa.client.Presenter;
import org.mut.ampa.client.screens.main.event.LogoutUserEvent;
import org.mut.ampa.shared.LoginCredential;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.Widget;

public class MainAppPresenter implements Presenter{

	public interface Display{
	      Widget asWidget();
	      HasClickHandlers getUnLoginButton();
		  void setAmpaTitle(String title);
		  void setLogedUserInfo(String userInfo);
		  public HasWidgets getInnerContainner();
	  }
	
		
	private final HandlerManager eventBus;
	private final Display display;
	
	
	
	public MainAppPresenter(HandlerManager eventBus,Display display,LoginCredential credencial) 
	{
	
		this.eventBus = eventBus;
	    this.display = display;
	    
	    this.display.setAmpaTitle("AMPA la Rosella");
	    this.display.setLogedUserInfo(credencial.getNom());
	    
	    bind();
	}
	
	private void bind() {
		 display.getUnLoginButton().addClickHandler(new ClickHandler() {
		      public void onClick(ClickEvent event) {
		    	  logout();
		    	  
		      }
		
		    });
		
	}

	@Override
	public void go(HasWidgets container) {
		container.clear();
		container.add(display.asWidget());
		
	}
	
	public HasWidgets getInnerContainer(){ return display.getInnerContainner();}
	
	private void logout() {
		eventBus.fireEvent(new LogoutUserEvent());
	}

}
