package org.mut.ampa.client.screens.main.view;

import org.mut.ampa.client.widget.menu.BasicMenu;
import org.mut.ampa.client.widget.title.AmpaTitle;
import org.mut.ampa.shared.LoginCredential;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

public class MainAppView extends Composite implements org.mut.ampa.client.screens.main.presenter.MainAppPresenter.Display
{
	private final MainAppResources resources =  GWT.create(MainAppResources.class);
	
	private final DockPanel         root       = new DockPanel();
	private final HorizontalPanel   title    = new HorizontalPanel();
	private final BasicMenu         menu ;
	private final VerticalPanel     main     = new VerticalPanel();
			
	private final AmpaTitle ampaTitle        = new AmpaTitle();
	
	
	public MainAppView(LoginCredential credential) 
	{
		//inicialitzem objecte estils
		resources.style().ensureInjected();
		
		initWidget(root);
		root.setHeight("100%");
		root.setWidth("100%");
		
		root.setStyleName("cw-DockPanel");
		
		int h=Window.getClientHeight()-50;
		int w=Window.getClientWidth()-50;
		
		int ht =h/10;
		int mh = h-ht;
		int mw= w /7;
		int mm= w-mw;
		
		title.setHeight(ht+"px");
		title.setWidth(w+"px");
		
	    menu = new BasicMenu(mw,mh,credential);
//		menu.setHeight(mh+"px");
//		menu.setWidth(mw+"px");
		main.setHeight(mh+"px");
		main.setWidth(mm+"px");
//		main.getElement().getStyle().setMarginLeft(50, Unit.PX);
//		main.getElement().getStyle().setMarginTop(10, Unit.PX);
		
		root.add(title, DockPanel.NORTH);
		root.add(menu, DockPanel.WEST);
		root.add(main, DockPanel.CENTER);
		
		title.add(ampaTitle);
		
		title.setStyleName(resources.style().mainBackGround());
		
		
	}
	@Override
	public HasClickHandlers getUnLoginButton() {
		return ampaTitle.getUnLoginButton();
	}
	@Override
	public void setAmpaTitle(String title) {
		ampaTitle.setAmpaTitle(title);
		
	}
	@Override
	public void setLogedUserInfo(String userInfo) {
		ampaTitle.setLogedUserInfo(userInfo);
		
	}
	@Override
	public HasWidgets getInnerContainner(){return main;}
}
