package org.mut.ampa.client.screens.manteniment;

import java.util.HashMap;
import java.util.List;

import org.mut.ampa.shared.LoginCredential;
import org.mut.ampa.shared.exceptions.ServerSideException;
import org.mut.ampa.shared.exceptions.UnAuthorizedException;
import org.mut.ampa.shared.filter.Filter;
import org.mut.ampa.shared.model.Alumne;
import org.mut.ampa.shared.model.AlumneBrief;
import org.mut.ampa.shared.model.Associacio;
import org.mut.ampa.shared.model.Curs;
import org.mut.ampa.shared.model.CursGrupInfo;
import org.mut.ampa.shared.model.Tutor;
import org.mut.ampa.shared.model.Usuari;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

@RemoteServiceRelativePath("manteniment")
public interface MantenimentService extends RemoteService {
	
	public void registerCredential(LoginCredential credential);
	
	public List<Usuari> getUsuaris(LoginCredential credential,int offset,int maxElements) throws UnAuthorizedException, ServerSideException;
	public Usuari insertUsuari(LoginCredential credential, Usuari user)throws UnAuthorizedException, ServerSideException;
	public Usuari       updateUsuari(LoginCredential credential,Usuari user) throws UnAuthorizedException, ServerSideException;
	public List<Usuari> deleteUsuari(LoginCredential credential, Integer id) throws UnAuthorizedException, ServerSideException;
	public List<Usuari> findUsuari(LoginCredential credential,Filter filter) throws UnAuthorizedException, ServerSideException;

	public Associacio updateAssociacio(LoginCredential credencial, Associacio tmp) throws UnAuthorizedException, ServerSideException;
	public Associacio findAssociacio(LoginCredential credencial, int i) throws UnAuthorizedException, ServerSideException;
	public Associacio insertAssociacio(LoginCredential credencial, Associacio tmp) throws UnAuthorizedException, ServerSideException;

	public List<Curs> getCursos(LoginCredential credential, int i, int j) throws UnAuthorizedException, ServerSideException;
	public Curs insertCurs(LoginCredential credencial, Curs curs) throws UnAuthorizedException, ServerSideException;
	public Curs updateCurs(LoginCredential credencial, Curs curs) throws UnAuthorizedException, ServerSideException;
	public List<Curs> deleteCurs(LoginCredential credential, Integer id) throws UnAuthorizedException, ServerSideException;
	public List<Curs> findCurs(LoginCredential credential, Filter filterValues) throws UnAuthorizedException, ServerSideException;

	public List<CursGrupInfo> getGrups(LoginCredential credential, int i, int j)throws UnAuthorizedException, ServerSideException;
	public CursGrupInfo insertGrup(LoginCredential credencial, CursGrupInfo grup) throws UnAuthorizedException, ServerSideException;
	public CursGrupInfo updateGrup(LoginCredential credencial, CursGrupInfo grup)throws UnAuthorizedException, ServerSideException;
	public List<CursGrupInfo> deleteGrup(LoginCredential credential,int idGrup,int idCurs)throws UnAuthorizedException, ServerSideException;
	public List<CursGrupInfo> findGrup(LoginCredential credential, Filter filterValues)throws UnAuthorizedException, ServerSideException;

	public List<Tutor> getTutors(LoginCredential credential, int i, int j)throws UnAuthorizedException, ServerSideException;
	public Tutor insertTutor(LoginCredential credencial, Tutor tutor)throws UnAuthorizedException, ServerSideException;
	public Tutor updateTutor(LoginCredential credencial, Tutor tutor)throws UnAuthorizedException, ServerSideException;
	public List<Tutor> deleteTutor(LoginCredential credential, Integer id)throws UnAuthorizedException, ServerSideException;
	public List<Tutor> findTutors(LoginCredential credential, Filter filterValues)throws UnAuthorizedException, ServerSideException;

	public List<AlumneBrief> getAlumnes(LoginCredential credential, int i, int j)throws UnAuthorizedException, ServerSideException;
	public List<AlumneBrief> deleteAlumne(LoginCredential credential, Integer id)throws UnAuthorizedException, ServerSideException;
	public List<AlumneBrief> findAlumne(LoginCredential credential, Filter filterValues)throws UnAuthorizedException;
	public Alumne getAlumneInfo(LoginCredential credencial, AlumneBrief alumneBrief)throws UnAuthorizedException, ServerSideException;
	public List<AlumneBrief> getGermansInfo(LoginCredential credencial,AlumneBrief alumneBrief)throws UnAuthorizedException;
	
	public CursGrupInfo getGrupsCurs(LoginCredential credencial)throws UnAuthorizedException;
	public AlumneBrief insertAlumne(LoginCredential credencial, Alumne alumne)throws UnAuthorizedException;
	public AlumneBrief updateAlumne(LoginCredential credencial, Alumne alumne)throws UnAuthorizedException;
	public List<Tutor> getTutorsInfo(LoginCredential credencial,AlumneBrief alumneBrief)throws UnAuthorizedException;

	
	/*----- Reports */
	public String getPdfReport(LoginCredential credencial,String fileName,HashMap<String,Object> param)throws UnAuthorizedException,ServerSideException;

	

	

	
	}