package org.mut.ampa.client.screens.manteniment;

import java.util.HashMap;
import java.util.List;

import org.mut.ampa.shared.LoginCredential;
import org.mut.ampa.shared.exceptions.ServerSideException;
import org.mut.ampa.shared.filter.Filter;
import org.mut.ampa.shared.model.Alumne;
import org.mut.ampa.shared.model.AlumneBrief;
import org.mut.ampa.shared.model.Associacio;
import org.mut.ampa.shared.model.Curs;
import org.mut.ampa.shared.model.CursGrupInfo;
import org.mut.ampa.shared.model.Tutor;
import org.mut.ampa.shared.model.Usuari;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface MantenimentServiceAsync 
{
	void registerCredential(LoginCredential credential,	AsyncCallback<Void> callback);
	
	void getUsuaris(LoginCredential credential, int offset, int maxElements,AsyncCallback<List<Usuari>> callback);
	void insertUsuari(LoginCredential credential, Usuari user,AsyncCallback<Usuari> callback);
	void updateUsuari(LoginCredential credential, Usuari user,AsyncCallback<Usuari> callback);
	void deleteUsuari(LoginCredential credential,Integer id,AsyncCallback<List<Usuari>> asyncCallback);
	void findUsuari(LoginCredential credential,Filter filter,AsyncCallback<List<Usuari>> callback);
	
	void updateAssociacio(LoginCredential credencial, Associacio tmp,AsyncCallback<Associacio> asyncCallback);
	void findAssociacio(LoginCredential credencial, int i,AsyncCallback<Associacio> asyncCallback);
	void insertAssociacio(LoginCredential credencial, Associacio tmp,AsyncCallback<Associacio> asyncCallback);

	void getCursos(LoginCredential credential, int i, int j,AsyncCallback<List<Curs>> asyncCallback);
	void insertCurs(LoginCredential credencial, Curs curs,AsyncCallback<Curs> asyncCallback);
	void updateCurs(LoginCredential credencial, Curs curs,AsyncCallback<Curs> asyncCallback);
	void deleteCurs(LoginCredential credential, Integer id,AsyncCallback<List<Curs>> asyncCallback);
	void findCurs(LoginCredential credential, Filter filterValues,AsyncCallback<List<Curs>> asyncCallback);

	void getGrups(LoginCredential credential, int i, int j,AsyncCallback<List<CursGrupInfo>> asyncCallback);
	void insertGrup(LoginCredential credencial, CursGrupInfo grup,AsyncCallback<CursGrupInfo> asyncCallback);
	void updateGrup(LoginCredential credencial, CursGrupInfo grup,AsyncCallback<CursGrupInfo> asyncCallback);	
	void deleteGrup(LoginCredential credential,int idGrup,int idCurs,	AsyncCallback<List<CursGrupInfo>> asyncCallback);
	void findGrup(LoginCredential credential, Filter filterValues,AsyncCallback<List<CursGrupInfo>> asyncCallback);

	void getTutors(LoginCredential credential, int i, int j,AsyncCallback<List<Tutor>> asyncCallback);
	void insertTutor(LoginCredential credencial, Tutor tutor,AsyncCallback<Tutor> asyncCallback);
	void updateTutor(LoginCredential credencial, Tutor tutor,AsyncCallback<Tutor> asyncCallback);
	void deleteTutor(LoginCredential credential, Integer id,AsyncCallback<List<Tutor>> asyncCallback);
	void findTutors(LoginCredential credential, Filter filterValues,AsyncCallback<List<Tutor>> asyncCallback);

	
	void getAlumnes(LoginCredential credential, int i, int j,AsyncCallback<List<AlumneBrief>> asyncCallback);

	
	void deleteAlumne(LoginCredential credential, Integer id,AsyncCallback<List<AlumneBrief>> asyncCallback);
	void findAlumne(LoginCredential credential, Filter filterValues,AsyncCallback<List<AlumneBrief>> asyncCallback);
	void getAlumneInfo(LoginCredential credencial, AlumneBrief alumneBrief,AsyncCallback<Alumne> asyncCallback);

	void getGermansInfo(LoginCredential credencial, AlumneBrief alumneBrief,AsyncCallback<List<AlumneBrief>> asyncCallback);

	

	void getGrupsCurs(LoginCredential credencial,AsyncCallback<CursGrupInfo> asyncCallback);

	void insertAlumne(LoginCredential credencial, Alumne alumne,AsyncCallback<AlumneBrief> asyncCallback);

	void updateAlumne(LoginCredential credencial, Alumne alumne,AsyncCallback<AlumneBrief> asyncCallback);

	void getTutorsInfo(LoginCredential credencial, AlumneBrief alumneBrief,	AsyncCallback<List<Tutor>> asyncCallback);

	void getPdfReport(LoginCredential credencial,String fileName, HashMap<String, Object> param,AsyncCallback<String> callback);
	
	



}