package org.mut.ampa.client.screens.manteniment.alumne.view;

import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.alumne.presenter.AlumneEditPresenter;
import org.mut.ampa.client.widget.datagrid.DataGridSimple;
import org.mut.ampa.client.widget.selectBox.SelectBox;
import org.mut.ampa.shared.filter.Filter;
import org.mut.ampa.shared.model.AlumneBrief;
import org.mut.ampa.shared.model.Tutor;

import com.google.gwt.cell.client.TextCell;
import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.datepicker.client.DateBox;

/**
 * Pantalla de Manteniment de dades Tutors de l'aplicacio
 * @author Mario Unio UOC 2012
 *
 */
public class AlumneEditView extends Composite implements AlumneEditPresenter.Display
{
	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("ALUMNE");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	private final Button		  cancel     = new Button("Cancel·lar");
	
	
	private final TextBox idTextBox            = new TextBox();
	private final TextBox nomTextBox           = new TextBox();
	private final TextBox cognom1TextBox       = new TextBox();
	private final TextBox cognom2TextBox       = new TextBox();
	private final DateBox dataNaix             = new DateBox();
	private final TextBox adrecaTextBox        = new TextBox();
	private final TextBox poblacioTextBox      = new TextBox();
	private final ListBox cursListBox          = new ListBox();
	private final ListBox genereListBox        = new ListBox();
	private final TextBox tsiTextBox           = new TextBox();
	private final TextBox ccBancTextBox        = new TextBox();
	private final TextBox ccOfiTextBox         = new TextBox();
	private final TextBox ccDCTextBox          = new TextBox();
	private final TextBox ccNumeroTextBox      = new TextBox();
	private final PushButton  validar          ;
	private final ListBox usImatgeListBox      = new ListBox();
	private final PushButton  addBrotherButton ;  
	private final PushButton  delBrotherButton  ;
	private final DataGridSimple<AlumneBrief> germans;
	private static final String field1 ="Id";
	private static final String field2 ="Nom";
	private static final String field3 ="Cognom 1";
	private static final String field4 ="Cognom 2";
	private static final String field5 ="Grup";
	
	private final PushButton  addTutorButton;
	private final PushButton  delTutorButton;
	private final DataGridSimple<Tutor> tutors;
	
	private final TextBox observacionsTextBox  = new TextBox();
	private final TextBox alergiesTextBox  = new TextBox();
	
    private final DateTimeFormat dateFormat = DateTimeFormat.getFormat("dd/MM/yyyy");
	
	
	
	public AlumneEditView() 
	{
		resources.style().ensureInjected();
		
		validar    = new PushButton(new Image(resources.tickImage()));
		addBrotherButton= new PushButton(new Image(resources.addImage()));
		addBrotherButton.setStyleName(resources.style().buttonIcon());
		delBrotherButton= new PushButton(new Image(resources.crossImage()));
		delBrotherButton.setStyleName(resources.style().buttonIcon());
		addTutorButton= new PushButton(new Image(resources.addImage()));
		addTutorButton.setStyleName(resources.style().buttonIcon());
		delTutorButton= new PushButton(new Image(resources.crossImage()));
		delTutorButton.setStyleName(resources.style().buttonIcon());
		
		initWidget(root);
		
		tutors = new DataGridSimple<Tutor>(10,50,500) {
			
			@Override
			public void initColumnesTaula(DataGrid<Tutor> dataGrid,ListHandler<Tutor> sortHandler) 
			{
				initColumnsTutor(dataGrid,sortHandler);
				
			}

			
		};
		
		germans = new DataGridSimple<AlumneBrief>(10,50,500) {
			
			@Override
			public void initColumnesTaula(DataGrid<AlumneBrief> dataGrid,ListHandler<AlumneBrief> sortHandler) 
			{
				initColumnsGerma(dataGrid,sortHandler);
				
			}
		};
		
		botonera.add(desar);
		botonera.add(cancel);
			
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		
		
		//camp ID
		VerticalPanel idContainer = new VerticalPanel();
		Label idLabel= new Label("id");
		idTextBox.setWidth("30px");
		idTextBox.setEnabled(false);
		idTextBox.setStyleName(resources.style().usuTextBox());
		idContainer.add(idLabel);
		idContainer.add(idTextBox);

		
		
		//camp Nom
		VerticalPanel nomContainer = new VerticalPanel();
		Label nomLabel= new Label("Nom");
		nomTextBox.setWidth("60px");
		nomTextBox.setStyleName(resources.style().usuTextBox());
		nomContainer.add(nomLabel);
		nomContainer.add(nomTextBox);
		
		//camp CogNom1
		VerticalPanel cognom1Container = new VerticalPanel();
		Label cognom1Label= new Label("1er Cognom");
		cognom1TextBox.setWidth("160px");
		cognom1TextBox.setStyleName(resources.style().usuTextBox());
		cognom1Container.add(cognom1Label);
		cognom1Container.add(cognom1TextBox);
		
		//camp CogNom2
		VerticalPanel cognom2Container = new VerticalPanel();
		Label cognom2Label= new Label("2on Cognom");
		cognom2TextBox.setWidth("160px");
		cognom2TextBox.setStyleName(resources.style().usuTextBox());
		cognom2Container.add(cognom2Label);
		cognom2Container.add(cognom2TextBox);
		
		//camp Data inici
		VerticalPanel dataNaixContainer = new VerticalPanel();
		Label dataNaixLabel= new Label("Data naixement");
		dataNaix.setWidth("100px");
		dataNaix.setFormat(new DateBox.DefaultFormat(dateFormat));
		dataNaix.setStyleName(resources.style().usuTextBox());
		dataNaixContainer.add(dataNaixLabel);
		dataNaixContainer.add(dataNaix);
		
		HorizontalPanel row1= new HorizontalPanel();
		row1.add(idContainer);
		row1.add(nomContainer);
		row1.add(cognom1Container);
		row1.add(cognom2Container);
		row1.add(dataNaixContainer);
		layoutCamps.setWidget(1, 0, row1);
		
		//Adreça
		VerticalPanel adrecaContainer = new VerticalPanel();
		Label adrecaLabel= new Label("Adreça");
		adrecaTextBox.setWidth("280px");
		adrecaTextBox.setStyleName(resources.style().usuTextBox());
		adrecaContainer.add(adrecaLabel);
		adrecaContainer.add(adrecaTextBox);
				
		//Poblacio
		VerticalPanel poblacioContainer = new VerticalPanel();
		Label poblacioLabel= new Label("Poblacio");
		poblacioTextBox.setWidth("120px");
		poblacioTextBox.setStyleName(resources.style().usuTextBox());
		poblacioContainer.add(poblacioLabel);
		poblacioContainer.add(poblacioTextBox);
		
			
		//camp Curs
		VerticalPanel cursContainer = new VerticalPanel();
		Label cursLabel= new Label("Curs");
		cursListBox.setWidth("100px");
		cursListBox.setStyleName(resources.style().usuTextBox());
		cursContainer.add(cursLabel);
		cursContainer.add(cursListBox);
		cursListBox.addItem("P3-A");
		cursListBox.addItem("P3-B");
		cursListBox.addItem("P4-A");
		cursListBox.addItem("P5-A");
		cursListBox.addItem("1er-A");
		cursListBox.addItem("1er-B");
		cursListBox.addItem("2on-A");
		cursListBox.addItem("2on-B");
		cursListBox.addItem("2on-C");
		
		
		HorizontalPanel row2= new HorizontalPanel();
		row2.add(adrecaContainer);
		row2.add(poblacioContainer);
		row2.add(cursContainer);
		layoutCamps.setWidget(2, 0, row2);
		
		//camp Genere
		VerticalPanel genereContainer = new VerticalPanel();
		Label genereLabel= new Label("Genere");
		genereListBox.setWidth("60px");
		genereListBox.setStyleName(resources.style().usuTextBox());
		genereContainer.add(genereLabel);
		genereContainer.add(genereListBox);
		genereListBox.addItem("H");
		genereListBox.addItem("D");
		
		//tsi
		VerticalPanel tsiContainer = new VerticalPanel();
		Label tsiLabel= new Label("Nº Tarja Sanitària");
		tsiTextBox.setWidth("160px");
		tsiTextBox.setStyleName(resources.style().usuTextBox());
		tsiContainer.add(tsiLabel);
		tsiContainer.add(tsiTextBox);
		
		//camp dret imatge
		VerticalPanel usImatgeContainer = new VerticalPanel();
		Label usImatgeLabel= new Label("Ús Imatge ?");
		usImatgeListBox.setWidth("60px");
		usImatgeListBox.setStyleName(resources.style().usuTextBox());
		usImatgeContainer.add(usImatgeLabel);
		usImatgeContainer.add(usImatgeListBox);
		usImatgeListBox.addItem("S");
		usImatgeListBox.addItem("N");
		
		HorizontalPanel row3= new HorizontalPanel();
		row3.add(genereContainer);
		row3.add(tsiContainer);
		row3.add(usImatgeContainer);
		layoutCamps.setWidget(3, 0, row3);
				
		//camp CC
		VerticalPanel ccContainer = new VerticalPanel();
		Label ccLabel= new Label("Número Compte");
		
		ccBancTextBox.setStyleName(resources.style().ccTextBox());
		
		HorizontalPanel cc_container = new HorizontalPanel();
		ccBancTextBox.setWidth("60px");
		ccBancTextBox.setMaxLength(4);
		cc_container.add(ccBancTextBox);
		
		ccOfiTextBox.setStyleName(resources.style().ccTextBox());
		ccOfiTextBox.setWidth("40px");
		ccOfiTextBox.setMaxLength(4);
		cc_container.add(ccOfiTextBox);
		
		ccDCTextBox.setStyleName(resources.style().ccTextBox());
		ccDCTextBox.setWidth("20px");
		ccDCTextBox.setMaxLength(2);
		cc_container.add(ccDCTextBox);

		ccNumeroTextBox.setStyleName(resources.style().ccTextBox());
		ccNumeroTextBox.setWidth("80px");
		ccNumeroTextBox.setMaxLength(10);
		cc_container.add(ccNumeroTextBox);
		validar.setWidth("20px");
		cc_container.add(validar);
		
		ccContainer.add(ccLabel);
		ccContainer.add(cc_container);
		
		layoutCamps.setWidget(4, 0, ccContainer);
		
		//Grid Germans
		
		VerticalPanel germansContainer = new VerticalPanel();
		Label germansLabel= new Label("Germans");
		
		HorizontalPanel gridGermans_container = new HorizontalPanel();
		gridGermans_container.add(addBrotherButton);
		gridGermans_container.add(delBrotherButton);
	
		germansContainer.add(germansLabel);
		germansContainer.add(gridGermans_container);
		germansContainer.add(germans);
		layoutCamps.setWidget(5, 0, germansContainer);
		
		
		//Grid Tutors
		VerticalPanel tutorsContainer = new VerticalPanel();
		Label tutorsLabel= new Label("Tutors");
				
		HorizontalPanel gridtutor_container = new HorizontalPanel();
		gridtutor_container.add(addTutorButton);
		gridtutor_container.add(delTutorButton);
		tutorsContainer.add(tutorsLabel);
		tutorsContainer.add(gridtutor_container);
		tutorsContainer.add(tutors);
		layoutCamps.setWidget(6, 0, tutorsContainer);
		
		//Observacions
		VerticalPanel observacionsContainer = new VerticalPanel();
		Label observacionsLabel= new Label("Observacions");
		observacionsTextBox.setWidth("250px");
		observacionsTextBox.setStyleName(resources.style().usuTextBox());
		observacionsContainer.add(observacionsLabel);
		observacionsContainer.add(observacionsTextBox);
		
		//Alergies
		VerticalPanel alergiesContainer = new VerticalPanel();
		Label alergieLabel= new Label("Alergies");
		alergiesTextBox.setWidth("250px");
		alergiesTextBox.setStyleName(resources.style().usuTextBox());
		alergiesContainer.add(alergieLabel);
		alergiesContainer.add(alergiesTextBox);
		
		HorizontalPanel row4= new HorizontalPanel();
		row4.add(observacionsContainer);
		row4.add(alergiesContainer);
		layoutCamps.setWidget(7, 0, row4);
				
		
		border.add(layoutCamps);
		
		root.add(titol);
		root.add(border);
		root.add(botonera);
		
		setStyles();
		
		
//		addTutorButton.addClickHandler(new ClickHandler() {
//			
//			@Override
//			public void onClick(ClickEvent event) {
//				
//				SelectBox<Tutor> selectTutor = new SelectBox<Tutor>("Afegir Tutor",getMapTutorFields()) {
//					
//					@Override
//					protected List<Tutor> onClickCercar(Filter values) {
//					return null;
//					}
//					
//					@Override
//					protected void onClickAcceptar() {
//						// TODO Auto-generated method stub
//						
//					}
//				};
//				
//				selectTutor.show();
//			}
//		});
	}
	
	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		cancel.setStyleName(resources.style().editionButton());
		border.setStyleName("");
		
		
	}

	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getCancelButton() {
		return cancel;
	}

	@Override
	public HasValue<String> getIdTextBox() {
		
		return this.idTextBox;
	}

	@Override
	public HasValue<String> getNomTextBox() {
		return this.nomTextBox;
	}

	@Override
	public HasValue<String> getCognom1TextBox() {
		return this.cognom1TextBox;
	}

	@Override
	public HasValue<String> getCognom2TextBox() {
		return this.cognom2TextBox;
	}

	@Override
	public HasValue<Date> getDataNaixementDate() {
		return this.dataNaix;
	}

	@Override
	public HasValue<String> getAdrecaTextBox() {
		return this.adrecaTextBox;
	}

	@Override
	public HasValue<String> getPoblacioTextBox() {
		return this.poblacioTextBox;
	}

	@Override
	public ListBox getGrupListBox() {
		return this.cursListBox;
	}

	@Override
	public ListBox getGenereListBox() {
		return this.genereListBox;
	}

	@Override
	public HasValue<String> getTSITextBox() {
		return this.tsiTextBox;
	}

	@Override
	public HasValue<String> getCCBancTextBox() {
		return this.ccBancTextBox;
	}

	@Override
	public HasValue<String> getCCOficinaTextBox() {
		return this.ccOfiTextBox;
	}

	@Override
	public HasValue<String> getCCDCTextBox() {
	return this.ccDCTextBox;
	}

	@Override
	public HasValue<String> getCCNumTextBox() {
		return this.ccNumeroTextBox;
	}

	@Override
	public HasClickHandlers getValidateCCButton() {
		return this.validar;
	}

	@Override
	public ListBox getDretImatgeListBox() {
		return this.usImatgeListBox;
	}

	@Override
	public HasClickHandlers getAddTutorButton() {
		return this.addTutorButton;
	}

	@Override
	public HasClickHandlers getRemoveTutorButton() {
		return this.delTutorButton;
	}

	@Override
	public Tutor getSelectedTutor() {
		return tutors.getCurrentFila();
	}

	@Override
	public void setTutors(List<Tutor> data) {
		tutors.setDataList(data);
	}

	@Override
	public HasClickHandlers getAddBrotherButton() {
			return this.addBrotherButton;
	}

	@Override
	public HasClickHandlers getRemoveBrotherButton() {
		return this.delBrotherButton;
	}

	@Override
	public AlumneBrief getSelectedBrother() {
		return germans.getCurrentFila();
	}

	@Override
	public void setBrothers(List<AlumneBrief> data) {
		germans.setDataList(data);
		
	}

	@Override
	public HasValue<String> getObservacionsTextBox() {
		return this.observacionsTextBox;
	}

	@Override
	public HasValue<String> getAlergiesTextBox() {
		return this.alergiesTextBox;
	}

	private void initColumnsGerma(DataGrid<AlumneBrief> dataGrid,ListHandler<AlumneBrief> sortHandler) 
	{
		//---- iniciem columna id Alumne----------------------------------------------------
			Column<AlumneBrief, String> columnaId = new Column<AlumneBrief, String>(new TextCell()){
					              @Override
					              public String getValue(AlumneBrief object) {
					                  return String.valueOf(((AlumneBrief) object).getId());
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnaId, field1);
			dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnaId, new Comparator<AlumneBrief>() {
	            public int compare(AlumneBrief o1, AlumneBrief o2) {
	                return ((AlumneBrief) o1).getId() - ((AlumneBrief) o2).getId();
	            }
	        });
			columnaId.setSortable(true);
//---- iniciem columna Nom ----------------------------------------------------
			Column<AlumneBrief, String> nom = new Column<AlumneBrief, String>(new TextCell()){
					              @Override
					              public String getValue(AlumneBrief object) {
					                  return ((AlumneBrief) object).getNom();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(nom, field2);
			dataGrid.setColumnWidth(nom, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(nom, new Comparator<AlumneBrief>() {
	            public int compare(AlumneBrief o1, AlumneBrief o2) {
	                return ((AlumneBrief) o1).getNom().compareTo(
	                        ((AlumneBrief) o2).getNom());
	            }
	        });
			nom.setSortable(true);
//---- iniciem columna cognom1 ----------------------------------------------------
	Column<AlumneBrief, String> cognom1 = new Column<AlumneBrief, String>(new TextCell()){
			              @Override
			              public String getValue(AlumneBrief object) {
			                  return ((AlumneBrief) object).getCognom1();
			              }
			          };
			          
			          
	//Aspecte columna		          
	dataGrid.addColumn(cognom1, field3);
	dataGrid.setColumnWidth(cognom1, 80, Unit.PCT);
	//Handler per ordenar
	sortHandler.setComparator(cognom1, new Comparator<AlumneBrief>() {
        public int compare(AlumneBrief o1, AlumneBrief o2) {
            return ((AlumneBrief) o1).getCognom1().compareTo(
                    ((AlumneBrief) o2).getCognom1());
        }
    });
	cognom1.setSortable(true);

//---- iniciem columna cognom2 ----------------------------------------------------
			Column<AlumneBrief, String> cognom2 = new Column<AlumneBrief, String>(new TextCell()){
					              @Override
					              public String getValue(AlumneBrief object) {
					                  return ((AlumneBrief) object).getCognom2();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(cognom2, field4);
			dataGrid.setColumnWidth(cognom2, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(cognom2, new Comparator<AlumneBrief>() {
	            public int compare(AlumneBrief o1, AlumneBrief o2) {
	                return ((AlumneBrief) o1).getCognom2().compareTo(
	                        ((AlumneBrief) o2).getCognom2());
	            }
	        });
			cognom2.setSortable(true);

			Column<AlumneBrief, String> cursDesc = new Column<AlumneBrief, String>(new TextCell()){
					              @Override
					              public String getValue(AlumneBrief object) {
					                  return ((AlumneBrief) object).getCursDescripcio();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(cursDesc, field5);
			dataGrid.setColumnWidth(cursDesc, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(cursDesc, new Comparator<AlumneBrief>() {
	            public int compare(AlumneBrief o1, AlumneBrief o2) {
	                return ((AlumneBrief) o1).getCursDescripcio().compareTo(
	                        ((AlumneBrief) o2).getCursDescripcio());
	            }
	        });
			cursDesc.setSortable(true);
		
	}

	
	private void initColumnsTutor(DataGrid<Tutor> dataGrid,	ListHandler<Tutor> sortHandler) 
	{
		//---- iniciem columna id ----------------------------------------------------
			Column<Tutor, String> columnaId = new Column<Tutor, String>(new TextCell()){
					              @Override
					              public String getValue(Tutor object) {
					                  return String.valueOf(((Tutor) object).getId());
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnaId, field1);
			dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnaId, new Comparator<Tutor>() {
	            public int compare(Tutor o1, Tutor o2) {
	                return ((Tutor) o1).getId() - ((Tutor) o2).getId();
	            }
	        });
			columnaId.setSortable(true);
//---- iniciem columna nom ----------------------------------------------------
			Column<Tutor, String> columnanomTutor = new Column<Tutor, String>(new TextCell()){
					              @Override
					              public String getValue(Tutor object) {
					                  return ((Tutor) object).getNom();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnanomTutor, field2);
			dataGrid.setColumnWidth(columnanomTutor, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnanomTutor, new Comparator<Tutor>() {
	            public int compare(Tutor o1, Tutor o2) {
	                return ((Tutor) o1).getNom().compareTo(
	                        ((Tutor) o2).getNom());
	            }
	        });
			columnanomTutor.setSortable(true);
	
//---- iniciem columna cognom1 ----------------------------------------------------
			Column<Tutor, String> columnaCognom1 = new Column<Tutor, String>(new TextCell()){
					              @Override
					              public String getValue(Tutor object) {
					                  return ((Tutor) object).getCognom1();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnaCognom1, field3);
			dataGrid.setColumnWidth(columnaCognom1, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnaCognom1, new Comparator<Tutor>() {
	            public int compare(Tutor o1, Tutor o2) {
	                return ((Tutor) o1).getCognom1().compareTo(
	                        ((Tutor) o2).getCognom1());
	            }
	        });
			columnaCognom1.setSortable(true);
		//---- iniciem columna cognom2 ----------------------------------------------------
			Column<Tutor, String> columnaCognom2 = new Column<Tutor, String>(new TextCell()){
					              @Override
					              public String getValue(Tutor object) {
					                  return ((Tutor) object).getCognom2();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnaCognom2, field4);
			dataGrid.setColumnWidth(columnaCognom2, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnaCognom2, new Comparator<Tutor>() {
	            public int compare(Tutor o1, Tutor o2) {
	                return ((Tutor) o1).getCognom2().compareTo(
	                        ((Tutor) o2).getCognom2());
	            }
	        });
			columnaCognom2.setSortable(true);
		}

	
	private Map<Integer, String> getMapTutorFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,"Nom Tutor");
		filter.put(1,"Cognom 1");
		filter.put(2,"Cognom 2");
			
		return filter;
	}
}
