package org.mut.ampa.client.screens.manteniment.alumne.view;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.widget.datagrid.DataGridPaginat;
import org.mut.ampa.client.screens.manteniment.alumne.presenter.AlumneListPresenter;
import org.mut.ampa.shared.model.AlumneBrief;

import com.google.gwt.cell.client.TextCell;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;

public class AlumneListEdit  extends DataGridPaginat<AlumneBrief> implements AlumneListPresenter.Display
{
	private static final String title="Manteniment Alumnes";	
	private static final String field1 ="Id";
	private static final String field2 ="Nom";
	private static final String field3 ="Cognom 1";
	private static final String field4 ="Cognom 2";
	private static final String field5 ="Grup";
	
	
	public AlumneListEdit(int pageSize,boolean visible[],int h,int w) {
		super(title,pageSize,visible,h,w);
	
	}

	@Override
	public void initColumnesTaula(DataGrid<AlumneBrief> dataGrid,	ListHandler<AlumneBrief> sortHandler) {
		
		//---- iniciem columna id Alumne----------------------------------------------------
				if(visible[0])
				{	
					Column<AlumneBrief, String> columnaId = new Column<AlumneBrief, String>(new TextCell()){
							              @Override
							              public String getValue(AlumneBrief object) {
							                  return String.valueOf(((AlumneBrief) object).getId());
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaId, field1);
					dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaId, new Comparator<AlumneBrief>() {
			            public int compare(AlumneBrief o1, AlumneBrief o2) {
			                return ((AlumneBrief) o1).getId() - ((AlumneBrief) o2).getId();
			            }
			        });
					columnaId.setSortable(true);
				}
		//---- iniciem columna Nom ----------------------------------------------------
				if(visible[1])
				{	
					Column<AlumneBrief, String> nom = new Column<AlumneBrief, String>(new TextCell()){
							              @Override
							              public String getValue(AlumneBrief object) {
							                  return ((AlumneBrief) object).getNom();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(nom, field2);
					dataGrid.setColumnWidth(nom, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(nom, new Comparator<AlumneBrief>() {
			            public int compare(AlumneBrief o1, AlumneBrief o2) {
			                return ((AlumneBrief) o1).getNom().compareTo(
			                        ((AlumneBrief) o2).getNom());
			            }
			        });
					nom.setSortable(true);
				}
		//---- iniciem columna cognom1 ----------------------------------------------------
		if(visible[2])
		{	
			Column<AlumneBrief, String> cognom1 = new Column<AlumneBrief, String>(new TextCell()){
					              @Override
					              public String getValue(AlumneBrief object) {
					                  return ((AlumneBrief) object).getCognom1();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(cognom1, field3);
			dataGrid.setColumnWidth(cognom1, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(cognom1, new Comparator<AlumneBrief>() {
	            public int compare(AlumneBrief o1, AlumneBrief o2) {
	                return ((AlumneBrief) o1).getCognom1().compareTo(
	                        ((AlumneBrief) o2).getCognom1());
	            }
	        });
			cognom1.setSortable(true);
		}
		
		//---- iniciem columna cognom2 ----------------------------------------------------
				if(visible[3])
				{	
					Column<AlumneBrief, String> cognom2 = new Column<AlumneBrief, String>(new TextCell()){
							              @Override
							              public String getValue(AlumneBrief object) {
							                  return ((AlumneBrief) object).getCognom2();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(cognom2, field4);
					dataGrid.setColumnWidth(cognom2, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(cognom2, new Comparator<AlumneBrief>() {
			            public int compare(AlumneBrief o1, AlumneBrief o2) {
			                return ((AlumneBrief) o1).getCognom2().compareTo(
			                        ((AlumneBrief) o2).getCognom2());
			            }
			        });
					cognom2.setSortable(true);
				}
		
				if(visible[4])
				{	
					Column<AlumneBrief, String> cursDesc = new Column<AlumneBrief, String>(new TextCell()){
							              @Override
							              public String getValue(AlumneBrief object) {
							                  return ((AlumneBrief) object).getCursDescripcio();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(cursDesc, field5);
					dataGrid.setColumnWidth(cursDesc, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(cursDesc, new Comparator<AlumneBrief>() {
			            public int compare(AlumneBrief o1, AlumneBrief o2) {
			                return ((AlumneBrief) o1).getCursDescripcio().compareTo(
			                        ((AlumneBrief) o2).getCursDescripcio());
			            }
			        });
					cursDesc.setSortable(true);
				}
				
				
	}

	@Override
	public HasClickHandlers getAddButton() {
		return getParentAddButton();
	}

	@Override
	public HasClickHandlers getDeleteButton() {
		return getParentDeleteButton();
	}

	@Override
	public void setData(List<AlumneBrief> data) {
		setDataList(data);	
	}

	
	@Override
	public HasClickHandlers getFilterButton() {
		return getParentSearchButton();
	}
	
	@Override
	public HasClickHandlers getEditButton() {
		return getParentEditButton();
	}

	@Override
	public AlumneBrief getSelectedEntity() {
		return  getCurrentFila();
	}

	@Override
	public Map<Integer, String> getFilterFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,field2);
		filter.put(1,field3);
		filter.put(2,field4);
		filter.put(3,field5);
		
		return filter;
	}

	


}
