package org.mut.ampa.client.screens.manteniment.associacio.view;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.associacio.presenter.AssociacioEditPresenter;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
/**
 * Pantalla manteniment dades Associacio
 * @author Mario Unio UOC 2012
 *
 */
public class AssociacioEditView extends Composite implements AssociacioEditPresenter.Display
{

	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("DADES ASSOCIACIÓ");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	
	
	private final TextBox nomTextBox      = new TextBox();
	private final TextBox nifTextBox      = new TextBox();
	private final TextBox adrecaTextBox   = new TextBox();
	private final TextBox poblacioTextBox = new TextBox();
	private final TextBox ccBancTextBox   = new TextBox();
	private final TextBox ccOfiTextBox    = new TextBox();
	private final TextBox ccDCTextBox     = new TextBox();
	private final TextBox ccNumeroTextBox = new TextBox();
	private final PushButton  validar;
	private final TextBox sufixTextBox    = new TextBox();
	
	public AssociacioEditView() 
	{
		resources.style().ensureInjected();
		
		validar    = new PushButton(new Image(resources.tickImage()));
		
		initWidget(root);
		botonera.add(desar);
		
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);
		
		//camp Nom Associacio
		layoutCamps.setHTML(1, 0, "Nom");
		nomTextBox.setWidth("200px");
		nomTextBox.setMaxLength(45);
		nomTextBox.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(1, 1, nomTextBox);
		
		//camp NIF
		layoutCamps.setHTML(2, 0, "Nif");
		nifTextBox.setWidth("120px");
		nifTextBox.setMaxLength(12);
		nifTextBox.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(2, 1, nifTextBox);
		
		//camp CC
		layoutCamps.setHTML(5, 0, "Número Compte");
		ccBancTextBox.setStyleName(resources.style().ccTextBox());
		
		HorizontalPanel cc_container = new HorizontalPanel();
		ccBancTextBox.setWidth("60px");
		ccBancTextBox.setMaxLength(4);
		cc_container.add(ccBancTextBox);
		
		ccOfiTextBox.setStyleName(resources.style().ccTextBox());
		ccOfiTextBox.setWidth("40px");
		ccOfiTextBox.setMaxLength(4);
		cc_container.add(ccOfiTextBox);
		
		ccDCTextBox.setStyleName(resources.style().ccTextBox());
		ccDCTextBox.setWidth("20px");
		ccDCTextBox.setMaxLength(2);
		cc_container.add(ccDCTextBox);

		ccNumeroTextBox.setStyleName(resources.style().ccTextBox());
		ccNumeroTextBox.setWidth("80px");
		ccNumeroTextBox.setMaxLength(10);
		cc_container.add(ccNumeroTextBox);
		validar.setWidth("20px");
		cc_container.add(validar);
		
		layoutCamps.setWidget(5, 1, cc_container);
		
		//camp Sufix Remesa
		layoutCamps.setHTML(6, 0, "Sufix Remesa");
		sufixTextBox.setWidth("60px");
		sufixTextBox.setMaxLength(3);
		sufixTextBox.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(6, 1, sufixTextBox);
		
		border.add(layoutCamps);
		root.add(titol);
		root.add(border);
		root.add(botonera);

		setStyles();
	}

	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		border.setStyleName("");
	}

	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getValidateCCButton() {
		return validar;
	}

	@Override
	public HasValue<String> getNomTextBox() {
		return nomTextBox;
	}

	@Override
	public HasValue<String> getNifTextBox() {
		return nifTextBox;
	}

	@Override
	public HasValue<String> getAdrecaTextBox() {
		return adrecaTextBox;
	}

	@Override
	public HasValue<String> getPoblacioTextBox() {
		return poblacioTextBox;
	}

	@Override
	public HasValue<String> getCCBancTextBox() {
		return ccBancTextBox;
	}

	@Override
	public HasValue<String> getCCOficinaTextBox() {
		return ccOfiTextBox;
	}

	@Override
	public HasValue<String> getCCDCTextBox() {
		return ccDCTextBox;
	}

	@Override
	public HasValue<String> getCCNumTextBox() {
		return ccNumeroTextBox;
	}

	@Override
	public HasValue<String> getSufixTextBox() {
		return sufixTextBox;
	}
	
}
