package org.mut.ampa.client.screens.manteniment.contracte.view;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.contracte.presenter.ContractarPresenter;
import org.mut.ampa.client.widget.selectBox.SelectBox;
import org.mut.ampa.shared.model.AlumneBrief;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.datepicker.client.DateBox;
/**
 * Pantalla manteniment dades Associacio
 * @author Mario Unio UOC 2012
 *
 */
public class ContractarView extends Composite implements ContractarPresenter.Display
{

	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	private final DateTimeFormat dateFormat = DateTimeFormat.getFormat("dd/MM/yyyy");
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("CONTRACTAR SERVEI");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Contractar");
	private  SelectBox<AlumneBrief>   alumneSelector;
	
	private final TextBox     alumneTextBox      = new TextBox();
	private final PushButton  cercarAlumne;
	private final ListBox     serveiListBox      = new ListBox();
	private final DateBox     start             = new DateBox();
	private final DateBox     end               = new DateBox();
	
	
	public ContractarView() 
	{
		resources.style().ensureInjected();
		
		cercarAlumne    = new PushButton(new Image(resources.addAlumneImage()));
		
		
		initWidget(root);
		botonera.add(desar);
		
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);
		
		//camp Alumne
		layoutCamps.setHTML(1, 0, "Alumne");
		alumneTextBox.setWidth("300px");
		alumneTextBox.setMaxLength(200);
		alumneTextBox.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(1, 1, alumneTextBox);
		layoutCamps.setWidget(1, 2, cercarAlumne);
		
		
		
		//camp Servei
		layoutCamps.setHTML(2, 0, "Servei");
		serveiListBox.setWidth("300px");
		serveiListBox.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(2, 1, serveiListBox);
		
				
		//camp Data Inici
		layoutCamps.setHTML(6, 0, "Data inici");
		start.setWidth("100px");
		start.setFormat(new DateBox.DefaultFormat(dateFormat));
		start.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(6, 1, start);
		
		//camp Data Inici
		layoutCamps.setHTML(7, 0, "Data fi");
		end.setWidth("100px");
		end.setFormat(new DateBox.DefaultFormat(dateFormat));		
		end.setStyleName(resources.style().assocTextBox());
		layoutCamps.setWidget(7, 1, end);
		
		border.add(layoutCamps);
		root.add(titol);
		root.add(border);
		root.add(botonera);

		setStyles();
		
		alumneSelector = new SelectBox<AlumneBrief>("Cercar Alumne",getMapTutorFields());
		((DialogBox)alumneSelector).hide();
	}

	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		border.setStyleName("");
	}

	@Override
	public HasClickHandlers getContractarButton() {
		return desar;
	}

	@Override
	public HasValue<String> getAlumneTextBox() {
		return alumneTextBox;
	}

	@Override
	public HasClickHandlers getSearchAlumnesButton() {
		return alumneSelector.getAddButton();
	}

	@Override
	public ListBox getServeiListBox() {
		return serveiListBox;
	}

	@Override
	public HasValue<Date> getStartDate() {
		return start;
	}

	@Override
	public HasValue<Date> getEndDate() {
		return end;
	}

	@Override
	public HasClickHandlers getAddAlumneToContractButton() {
		return cercarAlumne;
		
	}

	@Override
	public HasClickHandlers getSeleccionarAlumne() {
		return alumneSelector.getSelectButton();
	}

	@Override
	public HasClickHandlers getCancelAddAlumne() {
		return alumneSelector.getCancelButton();
	}
	
	private Map<Integer, String> getMapTutorFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,"Nom ");
		filter.put(1,"Cognom 1");
		filter.put(2,"Cognom 2");
			
		return filter;
	}

	@Override
	public SelectBox<AlumneBrief> searchBox() {
		return alumneSelector;
	}
	
}
