package org.mut.ampa.client.screens.manteniment.curs.view;

import java.util.Date;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.curs.presenter.CursEditPresenter;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.datepicker.client.DateBox;

/**
 * Pantalla de Manteniment de dades del curs escolar
 * @author Mario Unio UOC 2012
 *
 */
public class CursEditView extends Composite implements CursEditPresenter.Display
{
	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("CURS ESCOLAR");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	private final Button		  cancel     = new Button("Cancel·lar");
	
	
	private final TextBox idTextBox            = new TextBox();
	private final TextBox descripcio           = new TextBox();
	
	private final DateTimeFormat dateFormat = DateTimeFormat.getFormat("dd/MM/yyyy");
	
	private final DateBox start             = new DateBox();
	private final DateBox end               = new DateBox();
	
	
	public CursEditView() 
	{
		resources.style().ensureInjected();
		
		initWidget(root);
		
		botonera.add(desar);
		botonera.add(cancel);
			
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		layoutCamps.setHTML(1, 0, "Codi");
		
		//camp ID
		idTextBox.setWidth("30px");
		idTextBox.setEnabled(false);
		idTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(1, 1, idTextBox);
			
		//camp Nom
		layoutCamps.setHTML(2, 0, "Descripció");
		descripcio.setWidth("200px");
		descripcio.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(2, 1, descripcio);
		
		//camp Data inici

		
		layoutCamps.setHTML(3, 0, "Data inici");
		start.setWidth("100px");
	    start.setFormat(new DateBox.DefaultFormat(dateFormat));
	    start.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(3, 1, start);
		
		//camp Data Fi
		layoutCamps.setHTML(4, 0, "Data fi");
		end.setWidth("100px");
		end.setFormat(new DateBox.DefaultFormat(dateFormat));
		end.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(4, 1, end);
		
		border.add(layoutCamps);
		
		root.add(titol);
		root.add(border);
		root.add(botonera);
		
		setStyles();
	}
	
	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		cancel.setStyleName(resources.style().editionButton());
		border.setStyleName("");
	}


	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getCancelButton() {
		return cancel;
	}

	@Override
	public HasValue<String> getIdTextBox() {
		
		return this.idTextBox;
	}

	@Override
	public HasValue<String> getDescripcioTextBox() {
		return this.descripcio;
	}

	@Override
	public HasValue<Date> getStartDate() {
		return this.start;
	}

	@Override
	public HasValue<Date> getEndDate() {
		return this.end;
	}

	


	
}
