package org.mut.ampa.client.screens.manteniment.curs.view;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.screens.manteniment.curs.presenter.CursListPresenter;
import org.mut.ampa.client.widget.datagrid.DataGridPaginat;
import org.mut.ampa.shared.model.Curs;

import com.google.gwt.cell.client.TextCell;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;

public class CursListEdit  extends DataGridPaginat<Curs> implements CursListPresenter.Display
{
	private static final String title="Manteniment Curs";	
	private static final String field1 ="Id";
	private static final String field2 ="Descripcio";
	
	
	public CursListEdit(int pageSize,boolean visible[],int h,int w) {
		super(title,pageSize,visible,h,w);
	
	}

	@Override
	public void initColumnesTaula(DataGrid<Curs> dataGrid,	ListHandler<Curs> sortHandler) {
		
		//---- iniciem columna id ----------------------------------------------------
				if(visible[0])
				{	
					Column<Curs, String> columnaId = new Column<Curs, String>(new TextCell()){
							              @Override
							              public String getValue(Curs object) {
							                  return String.valueOf(((Curs) object).getId());
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaId, field1);
					dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaId, new Comparator<Curs>() {
			            public int compare(Curs o1, Curs o2) {
			                return ((Curs) o1).getId() - ((Curs) o2).getId();
			            }
			        });
					columnaId.setSortable(true);
				}
		//---- iniciem columna descripcio ----------------------------------------------------
				if(visible[1])
				{	
					Column<Curs, String> columnanomUsuari = new Column<Curs, String>(new TextCell()){
							              @Override
							              public String getValue(Curs object) {
							                  return ((Curs) object).getDescripcio();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnanomUsuari, field2);
					dataGrid.setColumnWidth(columnanomUsuari, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnanomUsuari, new Comparator<Curs>() {
			            public int compare(Curs o1, Curs o2) {
			                return ((Curs) o1).getDescripcio().compareTo(
			                        ((Curs) o2).getDescripcio());
			            }
			        });
					columnanomUsuari.setSortable(true);
				}
	
	}

	@Override
	public HasClickHandlers getAddButton() {
		return getParentAddButton();
	}

	@Override
	public HasClickHandlers getDeleteButton() {
		return getParentDeleteButton();
	}

	@Override
	public void setData(List<Curs> data) {
		setDataList(data);	
	}

	
	@Override
	public HasClickHandlers getFilterButton() {
		return getParentSearchButton();
	}
	
	@Override
	public HasClickHandlers getEditButton() {
		return getParentEditButton();
	}

	@Override
	public Curs getSelectedEntity() {
		return  getCurrentFila();
	}

	@Override
	public Map<Integer, String> getFilterFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,field2);
			
		return filter;
	}

	


}
