package org.mut.ampa.client.screens.manteniment.grup.view;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.grup.presenter.GrupEditPresenter;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Pantalla de Manteniment de dades GRUPS  de l'aplicacio
 * @author Mario Unio UOC 2012
 *
 */
public class GrupEditView extends Composite implements GrupEditPresenter.Display
{
	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("GRUP");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	private final Button		  cancel     = new Button("Cancel·lar");
	
	
	private final TextBox idGrupBox            = new TextBox();
	private final ListBox cursListBox          = new ListBox();
	private final TextBox nomGrupBox           = new TextBox();
	
	public GrupEditView() 
	{
		resources.style().ensureInjected();
		
		initWidget(root);
		
		botonera.add(desar);
		botonera.add(cancel);
			
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		
		
		//camp ID
		layoutCamps.setHTML(1, 0, "Codi");
		idGrupBox.setWidth("30px");
		idGrupBox.setEnabled(false);
		idGrupBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(1, 1, idGrupBox);
			
		//camp Curs
		layoutCamps.setHTML(2, 0, "Curs");
		cursListBox.setWidth("200px");
		cursListBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(2, 1, cursListBox);
		
		//camp Nom
		layoutCamps.setHTML(3, 0, "Descripció");
		nomGrupBox.setWidth("200px");
		nomGrupBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(3, 1, nomGrupBox);
		

		
		border.add(layoutCamps);
		
		root.add(titol);
		root.add(border);
		root.add(botonera);
		
		setStyles();
	}
	
	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		cancel.setStyleName(resources.style().editionButton());
		border.setStyleName("");
	}


	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getCancelButton() {
		return cancel;
	}

	@Override
	public HasValue<String> getIdGrupTextBox() {
		return idGrupBox;
	}

	@Override
	public HasValue<String> getGrupDescripcioTextBox() {
		return nomGrupBox;
	}

	@Override
	public ListBox getCursListBox() {
		return cursListBox;
	}


	
}
