package org.mut.ampa.client.screens.manteniment.grup.view;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.screens.manteniment.grup.presenter.GrupListPresenter;
import org.mut.ampa.client.widget.datagrid.DataGridPaginat;
import org.mut.ampa.shared.model.CursGrupInfo;


import com.google.gwt.cell.client.TextCell;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;

public class GrupListEdit  extends DataGridPaginat<CursGrupInfo> implements GrupListPresenter.Display
{
	private static final String title="Manteniment Grup";	
	private static final String field1 ="Id";
	private static final String field2 ="Grup";
	private static final String field3 ="Curs";
	
	
	public GrupListEdit(int pageSize,boolean visible[],int h,int w) {
		super(title,pageSize,visible,h,w);
	
	}

	@Override
	public void initColumnesTaula(DataGrid<CursGrupInfo> dataGrid,	ListHandler<CursGrupInfo> sortHandler) {
		
		//---- iniciem columna id Grup----------------------------------------------------
				if(visible[0])
				{	
					Column<CursGrupInfo, String> columnaId = new Column<CursGrupInfo, String>(new TextCell()){
							              @Override
							              public String getValue(CursGrupInfo object) {
							                  return String.valueOf(((CursGrupInfo) object).getIdGrup());
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaId, field1);
					dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaId, new Comparator<CursGrupInfo>() {
			            public int compare(CursGrupInfo o1, CursGrupInfo o2) {
			                return ((CursGrupInfo) o1).getIdGrup() - ((CursGrupInfo) o2).getIdGrup();
			            }
			        });
					columnaId.setSortable(true);
				}
		//---- iniciem columna nomGrup ----------------------------------------------------
				if(visible[1])
				{	
					Column<CursGrupInfo, String> grupNom = new Column<CursGrupInfo, String>(new TextCell()){
							              @Override
							              public String getValue(CursGrupInfo object) {
							                  return ((CursGrupInfo) object).getDescripcioGrup();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(grupNom, field2);
					dataGrid.setColumnWidth(grupNom, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(grupNom, new Comparator<CursGrupInfo>() {
			            public int compare(CursGrupInfo o1, CursGrupInfo o2) {
			                return ((CursGrupInfo) o1).getDescripcioGrup().compareTo(
			                        ((CursGrupInfo) o2).getDescripcioGrup());
			            }
			        });
					grupNom.setSortable(true);
				}
		//---- iniciem columna descripcio curs ----------------------------------------------------
		if(visible[2])
		{	
			Column<CursGrupInfo, String> cursNom = new Column<CursGrupInfo, String>(new TextCell()){
					              @Override
					              public String getValue(CursGrupInfo object) {
					                  return ((CursGrupInfo) object).getDescripcioCurs();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(cursNom, field3);
			dataGrid.setColumnWidth(cursNom, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(cursNom, new Comparator<CursGrupInfo>() {
	            public int compare(CursGrupInfo o1, CursGrupInfo o2) {
	                return ((CursGrupInfo) o1).getDescripcioCurs().compareTo(
	                        ((CursGrupInfo) o2).getDescripcioCurs());
	            }
	        });
			cursNom.setSortable(true);
		}
		
			}

	@Override
	public HasClickHandlers getAddButton() {
		return getParentAddButton();
	}

	@Override
	public HasClickHandlers getDeleteButton() {
		return getParentDeleteButton();
	}

	@Override
	public void setData(List<CursGrupInfo> data) {
		setDataList(data);	
	}

	
	@Override
	public HasClickHandlers getFilterButton() {
		return getParentSearchButton();
	}
	
	@Override
	public HasClickHandlers getEditButton() {
		return getParentEditButton();
	}

	@Override
	public CursGrupInfo getSelectedEntity() {
		return  getCurrentFila();
	}

	@Override
	public Map<Integer, String> getFilterFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,field2);
		filter.put(1,field3);
		
		
		return filter;
	}

	


}
