package org.mut.ampa.client.screens.manteniment.tutor.view;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.tutor.presenter.TutorEditPresenter;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Pantalla de Manteniment de dades Tutors de l'aplicacio
 * @author Mario Unio UOC 2012
 *
 */
public class TutorEditView extends Composite implements TutorEditPresenter.Display
{
	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("TUTOR");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	private final Button		  cancel     = new Button("Cancel·lar");
	
	
	private final TextBox idTextBox            = new TextBox();
	private final TextBox nomTextBox           = new TextBox();
	private final TextBox cognom1TextBox       = new TextBox();
	private final TextBox cognom2TextBox       = new TextBox();
	private final TextBox telefon1TextBox      = new TextBox();
	private final TextBox telefon2TextBox      = new TextBox();
	private final TextBox emailTextBox       = new TextBox();
	
	
	public TutorEditView() 
	{
		resources.style().ensureInjected();
		
		initWidget(root);
		
		botonera.add(desar);
		botonera.add(cancel);
			
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		layoutCamps.setHTML(1, 0, "Codi");
		
		//camp ID
		idTextBox.setWidth("30px");
		idTextBox.setEnabled(false);
		idTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(1, 1, idTextBox);
			
		//camp Nom
		layoutCamps.setHTML(2, 0, "Nom Tutor");
		nomTextBox.setWidth("60px");
		nomTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(2, 1, nomTextBox);
		
		//camp CogNom1
		layoutCamps.setHTML(3, 0, "1er Cognom");
		cognom1TextBox.setWidth("160px");
		cognom1TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(3, 1, cognom1TextBox);
		
		//camp CogNom2
		layoutCamps.setHTML(4, 0, "2on Cognom");
		cognom2TextBox.setWidth("160px");
		cognom2TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(4, 1, cognom2TextBox);
		
		//camp Telefon1
		layoutCamps.setHTML(5, 0, "1º Telèfon");
		telefon1TextBox.setWidth("160px");
		telefon1TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(5, 1, telefon1TextBox);
		
		//camp Telefon2
		layoutCamps.setHTML(6, 0, "2º Telèfon");
		telefon2TextBox.setWidth("160px");
		telefon2TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(6, 1, telefon2TextBox);
		
		//camp Email
		layoutCamps.setHTML(7, 0, "Email");
		emailTextBox.setWidth("160px");
		emailTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(7, 1, emailTextBox);
		
		
		border.add(layoutCamps);
		
		root.add(titol);
		root.add(border);
		root.add(botonera);
		
		setStyles();
	}
	
	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		cancel.setStyleName(resources.style().editionButton());
		border.setStyleName("");
		
	}


	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getCancelButton() {
		return cancel;
	}

	@Override
	public HasValue<String> getIdTextBox() {
		
		return this.idTextBox;
	}

	@Override
	public HasValue<String> getNomTextBox() {
		return this.nomTextBox;
	}

	@Override
	public HasValue<String> getCognom1TextBox() {
		return this.cognom1TextBox;
	}

	@Override
	public HasValue<String> getCognom2TextBox() {
		return this.cognom2TextBox;
	}

	@Override
	public HasValue<String> getTelefon1TextBox() {
		return this.telefon1TextBox;
	}

	@Override
	public HasValue<String> getTelefon2TextBox() {
		return this.telefon2TextBox;
	}

	@Override
	public HasValue<String> getEmailTextBox() {
		return this.emailTextBox;
	}


	
}
