package org.mut.ampa.client.screens.manteniment.tutor.view;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.screens.manteniment.tutor.presenter.TutorListPresenter;
import org.mut.ampa.client.widget.datagrid.DataGridPaginat;
import org.mut.ampa.shared.model.Tutor;


import com.google.gwt.cell.client.TextCell;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;

public class TutorListEdit  extends DataGridPaginat<Tutor> implements TutorListPresenter.Display
{
	private static final String title="Manteniment Tutor";	
	private static final String field1 ="Id";
	private static final String field2 ="Nom tutor";
	private static final String field3 ="Cognom 1";
	private static final String field4 ="Cognom 2";
	
	public TutorListEdit(int pageSize,boolean visible[],int h,int w) {
		super(title,pageSize,visible,h,w);
	
	}

	@Override
	public void initColumnesTaula(DataGrid<Tutor> dataGrid,	ListHandler<Tutor> sortHandler) {
		
		//---- iniciem columna id ----------------------------------------------------
				if(visible[0])
				{	
					Column<Tutor, String> columnaId = new Column<Tutor, String>(new TextCell()){
							              @Override
							              public String getValue(Tutor object) {
							                  return String.valueOf(((Tutor) object).getId());
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaId, field1);
					dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaId, new Comparator<Tutor>() {
			            public int compare(Tutor o1, Tutor o2) {
			                return ((Tutor) o1).getId() - ((Tutor) o2).getId();
			            }
			        });
					columnaId.setSortable(true);
				}
		//---- iniciem columna nom ----------------------------------------------------
				if(visible[1])
				{	
					Column<Tutor, String> columnanomTutor = new Column<Tutor, String>(new TextCell()){
							              @Override
							              public String getValue(Tutor object) {
							                  return ((Tutor) object).getNom();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnanomTutor, field2);
					dataGrid.setColumnWidth(columnanomTutor, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnanomTutor, new Comparator<Tutor>() {
			            public int compare(Tutor o1, Tutor o2) {
			                return ((Tutor) o1).getNom().compareTo(
			                        ((Tutor) o2).getNom());
			            }
			        });
					columnanomTutor.setSortable(true);
				}
			
		//---- iniciem columna cognom1 ----------------------------------------------------
				if(visible[2])
				{	
					Column<Tutor, String> columnaCognom1 = new Column<Tutor, String>(new TextCell()){
							              @Override
							              public String getValue(Tutor object) {
							                  return ((Tutor) object).getCognom1();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaCognom1, field3);
					dataGrid.setColumnWidth(columnaCognom1, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaCognom1, new Comparator<Tutor>() {
			            public int compare(Tutor o1, Tutor o2) {
			                return ((Tutor) o1).getCognom1().compareTo(
			                        ((Tutor) o2).getCognom1());
			            }
			        });
					columnaCognom1.setSortable(true);
				}
				//---- iniciem columna cognom2 ----------------------------------------------------
				if(visible[3])
				{	
					Column<Tutor, String> columnaCognom2 = new Column<Tutor, String>(new TextCell()){
							              @Override
							              public String getValue(Tutor object) {
							                  return ((Tutor) object).getCognom2();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaCognom2, field4);
					dataGrid.setColumnWidth(columnaCognom2, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaCognom2, new Comparator<Tutor>() {
			            public int compare(Tutor o1, Tutor o2) {
			                return ((Tutor) o1).getCognom2().compareTo(
			                        ((Tutor) o2).getCognom2());
			            }
			        });
					columnaCognom2.setSortable(true);
				}
	}

	@Override
	public HasClickHandlers getAddButton() {
		return getParentAddButton();
	}

	@Override
	public HasClickHandlers getDeleteButton() {
		return getParentDeleteButton();
	}

	@Override
	public void setData(List<Tutor> data) {
		setDataList(data);	
	}

	
	@Override
	public HasClickHandlers getFilterButton() {
		return getParentSearchButton();
	}
	
	@Override
	public HasClickHandlers getEditButton() {
		return getParentEditButton();
	}

	@Override
	public Tutor getSelectedEntity() {
		return  getCurrentFila();
	}

	@Override
	public Map<Integer, String> getFilterFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,field2);
		filter.put(1,field3);
		filter.put(2,field4);
			
		return filter;
	}

	


}
