package org.mut.ampa.client.screens.manteniment.usuari.view;

import org.mut.ampa.client.screens.ScreenResource;
import org.mut.ampa.client.screens.manteniment.usuari.presenter.UsuariEditPresenter;
import org.mut.ampa.shared.model.UsuariRol;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DecoratorPanel;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Pantalla de Manteniment de dades d'usuaris de l'aplicacio
 * @author Mario Unio UOC 2012
 *
 */
public class UsuariEditView extends Composite implements UsuariEditPresenter.Display
{
	private final ScreenResource resources =  GWT.create(ScreenResource.class);
	
	private final VerticalPanel   root       = new VerticalPanel();
	private final HTML            titol      = new HTML("USUARI");
	private final HorizontalPanel botonera   = new HorizontalPanel();
	private final DecoratorPanel  border     = new DecoratorPanel();
	private final FlexTable       layoutCamps= new FlexTable();
	private final Button		  desar      = new Button("Desar");
	private final Button		  cancel     = new Button("Cancel·lar");
	
	
	private final TextBox idTextBox            = new TextBox();
	private final TextBox nomUsuariTextBox     = new TextBox();
	private final TextBox passwordTextBox      = new TextBox();
	private final TextBox nomTextBox           = new TextBox();
	private final TextBox cognom1TextBox       = new TextBox();
	private final TextBox cognom2TextBox       = new TextBox();
	private final ListBox rolListBox           = new ListBox();
	
	
	public UsuariEditView() 
	{
		resources.style().ensureInjected();
		
		initWidget(root);
		
		botonera.add(desar);
		botonera.add(cancel);
			
		layoutCamps.setCellSpacing(6);
		FlexCellFormatter cellFormatter = layoutCamps.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		layoutCamps.setHTML(1, 0, "Codi");
		
		//camp ID
		idTextBox.setWidth("30px");
		idTextBox.setEnabled(false);
		idTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(1, 1, idTextBox);
			
		//camp Nom
		layoutCamps.setHTML(2, 0, "Nom Usuari");
		nomUsuariTextBox.setWidth("60px");
		nomUsuariTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(2, 1, nomUsuariTextBox);
		
		//camp Password
		layoutCamps.setHTML(3, 0, "Password");
		passwordTextBox.setWidth("60px");
		passwordTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(3, 1, passwordTextBox);
		
		//camp Nom
		layoutCamps.setHTML(4, 0, "Nom");
		nomTextBox.setWidth("160px");
		nomTextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(4, 1, nomTextBox);
		
		//camp CogNom1
		layoutCamps.setHTML(5, 0, "1er Cognom");
		cognom1TextBox.setWidth("160px");
		cognom1TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(5, 1, cognom1TextBox);
		
		//camp CogNom2
		layoutCamps.setHTML(6, 0, "2on Cognom");
		cognom2TextBox.setWidth("160px");
		cognom2TextBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(6, 1, cognom2TextBox);
		
		//camp Rol
		layoutCamps.setHTML(7, 0, "Rol");
		rolListBox.setWidth("110px");
		rolListBox.setStyleName(resources.style().usuTextBox());
		layoutCamps.setWidget(7, 1, rolListBox);
		
		rolListBox.addItem(UsuariRol.administrador.name());
		rolListBox.addItem(UsuariRol.soci.name());
		rolListBox.addItem(UsuariRol.tresorer.name());
		rolListBox.addItem(UsuariRol.usuari.name());
		
		border.add(layoutCamps);
		
		root.add(titol);
		root.add(border);
		root.add(botonera);
	
		setStyles();
	}

	
	private void setStyles() 
	{
		titol.setStyleName(resources.style().titolBox());
		root.setStyleName(resources.style().fonsPanell());
		desar.setStyleName(resources.style().editionButton());
		cancel.setStyleName(resources.style().editionButton());
		border.setStyleName("");
	}


	@Override
	public HasClickHandlers getSaveButton() {
		return desar;
	}

	@Override
	public HasClickHandlers getCancelButton() {
		return cancel;
	}

	@Override
	public HasValue<String> getIdTextBox() {
		
		return this.idTextBox;
	}

	@Override
	public HasValue<String> getNomUsuariTextBox() {
		return this.nomUsuariTextBox;
	}

	@Override
	public HasValue<String> getPasswordTextBox() {
		return this.passwordTextBox;
	}

	@Override
	public HasValue<String> getNomTextBox() {
		return this.nomTextBox;
	}

	@Override
	public HasValue<String> getCognom1TextBox() {
		return this.cognom1TextBox;
	}

	@Override
	public HasValue<String> getCognom2TextBox() {
		return this.cognom2TextBox;
	}

	@Override
	public ListBox getRolListBox() {
		return this.rolListBox;
	}



	
}
