package org.mut.ampa.client.screens.manteniment.usuari.view;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.mut.ampa.client.screens.manteniment.usuari.presenter.UsuariListPresenter;
import org.mut.ampa.client.widget.datagrid.DataGridPaginat;
import org.mut.ampa.shared.model.Usuari;

import com.google.gwt.cell.client.TextCell;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;

public class UsuariListEdit  extends DataGridPaginat<Usuari> implements UsuariListPresenter.Display
{
	private static final String title="Manteniment Usuari";	
	private static final String field1 ="Id";
	private static final String field2 ="Nom usuari";
	private static final String field3 ="Nom";
	private static final String field4 ="Cognom 1";
	private static final String field5 ="Cognom 2";
	
	public UsuariListEdit(int pageSize,boolean visible[],int h,int w) {
		super(title,pageSize,visible,h,w);
	
	}

	@Override
	public void initColumnesTaula(DataGrid<Usuari> dataGrid,	ListHandler<Usuari> sortHandler) {
		
		//---- iniciem columna id ----------------------------------------------------
				if(visible[0])
				{	
					Column<Usuari, String> columnaId = new Column<Usuari, String>(new TextCell()){
							              @Override
							              public String getValue(Usuari object) {
							                  return String.valueOf(((Usuari) object).getId());
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaId, field1);
					dataGrid.setColumnWidth(columnaId, 40, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaId, new Comparator<Usuari>() {
			            public int compare(Usuari o1, Usuari o2) {
			                return ((Usuari) o1).getId() - ((Usuari) o2).getId();
			            }
			        });
					columnaId.setSortable(true);
				}
		//---- iniciem columna nomUsuari ----------------------------------------------------
				if(visible[1])
				{	
					Column<Usuari, String> columnanomUsuari = new Column<Usuari, String>(new TextCell()){
							              @Override
							              public String getValue(Usuari object) {
							                  return ((Usuari) object).getNomUsuari();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnanomUsuari, field2);
					dataGrid.setColumnWidth(columnanomUsuari, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnanomUsuari, new Comparator<Usuari>() {
			            public int compare(Usuari o1, Usuari o2) {
			                return ((Usuari) o1).getNomUsuari().compareTo(
			                        ((Usuari) o2).getNomUsuari());
			            }
			        });
					columnanomUsuari.setSortable(true);
				}
		//---- iniciem columna nom ----------------------------------------------------
		if(visible[2])
		{	
			Column<Usuari, String> columnaNom = new Column<Usuari, String>(new TextCell()){
					              @Override
					              public String getValue(Usuari object) {
					                  return ((Usuari) object).getNom();
					              }
					          };
					          
					          
			//Aspecte columna		          
			dataGrid.addColumn(columnaNom, field3);
			dataGrid.setColumnWidth(columnaNom, 80, Unit.PCT);
			//Handler per ordenar
			sortHandler.setComparator(columnaNom, new Comparator<Usuari>() {
	            public int compare(Usuari o1, Usuari o2) {
	                return ((Usuari) o1).getNom().compareTo(
	                        ((Usuari) o2).getNom());
	            }
	        });
			columnaNom.setSortable(true);
		}
		
		//---- iniciem columna cognom1 ----------------------------------------------------
				if(visible[3])
				{	
					Column<Usuari, String> columnaCognom1 = new Column<Usuari, String>(new TextCell()){
							              @Override
							              public String getValue(Usuari object) {
							                  return ((Usuari) object).getCognom1();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaCognom1, field4);
					dataGrid.setColumnWidth(columnaCognom1, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaCognom1, new Comparator<Usuari>() {
			            public int compare(Usuari o1, Usuari o2) {
			                return ((Usuari) o1).getCognom1().compareTo(
			                        ((Usuari) o2).getCognom1());
			            }
			        });
					columnaCognom1.setSortable(true);
				}
				//---- iniciem columna cognom2 ----------------------------------------------------
				if(visible[4])
				{	
					Column<Usuari, String> columnaCognom2 = new Column<Usuari, String>(new TextCell()){
							              @Override
							              public String getValue(Usuari object) {
							                  return ((Usuari) object).getCognom2();
							              }
							          };
							          
							          
					//Aspecte columna		          
					dataGrid.addColumn(columnaCognom2, field5);
					dataGrid.setColumnWidth(columnaCognom2, 80, Unit.PCT);
					//Handler per ordenar
					sortHandler.setComparator(columnaCognom2, new Comparator<Usuari>() {
			            public int compare(Usuari o1, Usuari o2) {
			                return ((Usuari) o1).getCognom2().compareTo(
			                        ((Usuari) o2).getCognom2());
			            }
			        });
					columnaCognom2.setSortable(true);
				}
	}

	@Override
	public HasClickHandlers getAddButton() {
		return getParentAddButton();
	}

	@Override
	public HasClickHandlers getDeleteButton() {
		return getParentDeleteButton();
	}

	@Override
	public void setData(List<Usuari> data) {
		setDataList(data);	
	}

	
	@Override
	public HasClickHandlers getFilterButton() {
		return getParentSearchButton();
	}
	
	@Override
	public HasClickHandlers getEditButton() {
		return getParentEditButton();
	}

	@Override
	public Usuari getSelectedEntity() {
		return  getCurrentFila();
	}

	@Override
	public Map<Integer, String> getFilterFields() {
		Map<Integer, String> filter = new HashMap<Integer, String>();
		
		filter.put(0,field2);
		filter.put(1,field3);
		filter.put(2,field4);
		filter.put(3,field5);
		
		return filter;
	}

	


}
