package org.mut.ampa.client.widget.datagrid;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.shared.HasHandlers;
import com.google.gwt.user.cellview.client.ColumnSortEvent.ListHandler;
import com.google.gwt.user.cellview.client.DataGrid;
import com.google.gwt.user.cellview.client.SimplePager;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.view.client.ListDataProvider;
import com.google.gwt.view.client.NoSelectionModel;
import com.google.gwt.view.client.SelectionChangeEvent;

/**
 * Control que representa un grid Simple per a dades en forma de llista, 
 * @author Mario Unio UOC 2012
 *
 * @param <TipusFila>
 */
public abstract class DataGridSimple<TipusFila> extends Composite{

	private final DataGridResources resources =  GWT.create(DataGridResources.class);
	
	
	final private VerticalPanel root = new VerticalPanel();
	
	private TipusFila currentFila;
	public TipusFila getCurrentFila() {
		return currentFila;
	}

	private DataGrid<TipusFila> dataGrid ;	
		protected HasHandlers getParentList() {return dataGrid;}

	//final private SimplePager pager;
	
	private ListDataProvider<TipusFila> dataProvider;
	private final NoSelectionModel<TipusFila> selectionModel = new NoSelectionModel<TipusFila>();

	private String height;


	public DataGridSimple(int pageSize,int h,int w) {
		
		resources.style().ensureInjected();
		//Iniciar Widget contenidor (arrel del control)
		initWidget(root);
		root.setStyleName(resources.style().simpleListBox());
		dataGrid =new DataGrid<TipusFila>(pageSize);
		dataGrid.setHeight(h+"px");
		dataGrid.setWidth(w+"px");
		dataGrid.setVisible(true);
		dataGrid.setEmptyTableWidget(new HTML("Sense Dades"));
		
		
		SimplePager.Resources pagerResources = GWT.create(SimplePager.Resources.class);
       // pager = new SimplePager(TextLocation.CENTER, pagerResources, false, 0,true);
       // pager.setDisplay(dataGrid);
		
		//pager.setWidth("100%");
		//pager.setVisible(true);
		
		
		dataProvider = new ListDataProvider<TipusFila>();
		dataProvider.setList(new ArrayList<TipusFila>());
		
		ListHandler<TipusFila> sortHandler = new ListHandler<TipusFila>(dataProvider.getList());
		initColumnesTaula(dataGrid, sortHandler);
		dataProvider.addDataDisplay(dataGrid);
		dataGrid.addColumnSortHandler(sortHandler);
        
		//Definim el model de seleccio que sera de 1 fila
		dataGrid.setSelectionModel(selectionModel);		
		selectionModel.addSelectionChangeHandler(new SelectionChangeEvent.Handler() {
			
			public void onSelectionChange(SelectionChangeEvent event) {
				currentFila = selectionModel.getLastSelectedObject();
				
			}
		});
		
		//Afegit titol
		//Label screenTitle = new Label(title);
		//screenTitle.setStyleName(resources.style().titleBar());
		
		
		//root.add(screenTitle);
		root.add(dataGrid);
	//	root.add(pager);
		
		
	}

	/**
	 * Metode per afegir una columna al Grid
	 * @param dataGrid	  Datagrid.
	 * @param sortHandler Handler per a la ordenació.
	 */
	public abstract void initColumnesTaula(DataGrid<TipusFila> dataGrid,ListHandler<TipusFila> sortHandler);
	
    public List<TipusFila> getDataList() {
        	return dataProvider.getList();
    }
 
    public void setDataList(List<TipusFila> dataList) 
    {
    	 dataProvider.setList(dataList);
    	 dataProvider.refresh();
    }
 
    public ListDataProvider<TipusFila> getDataProvider() {
        return dataProvider;
    }
 
    public void setDataProvider(ListDataProvider<TipusFila> dataProvider) {
        this.dataProvider = dataProvider;
    }

    public String getHeight() {
    	        return height;
    	    }
    	 
    public void setHeight(String height) {
    	        this.height = height;
    	        dataGrid.setHeight(height);
    	    }

	
	
}
