package org.mut.ampa.client.widget.filterbox;

import java.util.Map;

import org.mut.ampa.shared.filter.Filter;
import org.mut.ampa.shared.filter.FilterField;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public  abstract class FilterBox extends DialogBox{

	//valors que s'ha introduït al filtre.
	private Filter values;
		public Filter getValues() {return values;}
	
	private final VerticalPanel root = new VerticalPanel();
	private final FlexTable filters  ; 
	
	
	
		
	
	public FilterBox(String title,Map<Integer,String> filterFields)
	{
		super(false,true);
				
		setText(title);
		
		//Crear tants camps com elements te el map		
		filters = genFilterFields(filterFields);
		root.add(filters);
		
		//Afegir boto Acceptar
		HorizontalPanel barraBotons = new HorizontalPanel();
		root.add(barraBotons);
		Button search = new Button("Cercar");
		search.addClickHandler(new ClickHandler() {
				
				@Override
				public void onClick(ClickEvent event) {
					
					FilterField[] fields = new FilterField[filters.getRowCount()];
					int i=0;		
					for (Widget widget : filters) {
						String campValor=((TextBox)widget).getValue();
						String camp=((TextBox)widget).getName();
						fields[i]= new FilterField(camp, campValor);
						i++;
					}
					values = new Filter(fields);
					onClickAcceptar();  
					FilterBox.this.hide();
				}
			});
			barraBotons.add(search);	

		Button cancelar = new Button("Cancel·lar");
		cancelar.addClickHandler(new ClickHandler() {
				
				@Override
				public void onClick(ClickEvent event) {
					FilterBox.this.hide();
				}
			});
			barraBotons.add(cancelar);	

		//afegim el contingut al DialogBox
		setWidget(root);
		
		FilterBox.this.setGlassEnabled(true);
		FilterBox.this.setAnimationEnabled(true);
		FilterBox.this.center();
		
	}
	
	protected abstract void onClickAcceptar();
	
	
	
	// Per cada objecte del map afegeix un textbox pel filtratge.
	private FlexTable genFilterFields(Map<Integer,String> filterFields)
	{
		FlexTable container = new FlexTable();
		
		container.setCellSpacing(6);
		FlexCellFormatter cellFormatter = container.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		int size = filterFields.keySet().size();
		int i=1;
		for (int j=0;j<size;j++) 
		{
			//etiqueta camp
			container.setHTML(i, 0, filterFields.get(j));
			container.setWidth("60px");
			//textBox la registrem
			TextBox tmp=new  TextBox();
			tmp.setName(filterFields.get(j));
			//Afegim el camp.
			container.setWidget(i, 1, tmp);	
			i++;
			
		}
		
		return container;
	} 
}
