package org.mut.ampa.client.widget.menu;

import org.mut.ampa.client.AppToken;
import org.mut.ampa.shared.LoginCredential;
import org.mut.ampa.shared.model.UsuariRol;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.StackLayoutPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class BasicMenu extends Composite 
{
	private final BasicMenuResources resources =  GWT.create(BasicMenuResources.class);
	
	private static final VerticalPanel root = new VerticalPanel();
	private static final StackLayoutPanel main = new StackLayoutPanel(Unit.PX);

	
	public BasicMenu(int w, int h,LoginCredential credential) {
		
				
		initWidget(root);
		main.setPixelSize(w, h);
		
	    // Afegir Grup d'opcions ALUMNES
	    Widget opAlumnes = crearGrupOpcions("Alumnes");
	    String[] opcionsNomAlum   = {"Manteniment Alumnes","Manteniment Tutors","Alumnes per curs","Alumnes validació dades","Alumnes assegurança"};
	    String[] opcionTokenAlum = {AppToken.TKN_MNT_ALUMNE,AppToken.TKN_MNT_TUTOR,AppToken.TKN_REPORT_ALUMNE1,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP};
	    boolean[] typeAlum ={false,false,true,true,true};  
	    main.add(afegirOpcions(opcionsNomAlum,opcionTokenAlum,typeAlum), opAlumnes, 40);
	   
	    // Afegir Grup d'opcions SERVEIS
	    Widget opServeis = crearGrupOpcions("Serveis");
	    String[] opcionsNomServei  = {"Manteniment Serveis","Tipus Serveis","Manteniment Espais","Manteniment Monitors","Control monitors"};
	    String[] opcionTokenServei = {AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP};
	    boolean[] typeServei ={false,false,false,false,true};
	    main.add(afegirOpcions(opcionsNomServei,opcionTokenServei,typeServei), opServeis, 40);
	    
	 // Afegir Grup d'opcions Contractar
	    Widget opContractar = crearGrupOpcions("Contractes");
	    String[] opcionsNomContracte  = {"Contractar","Manteniment Contractes","Extraescolars","Control menjador","Control acollida"};
	    String[] opcionTokenContracte = {AppToken.TKN_CONTRACTAR,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP};
	    boolean[] typeContracte ={false,false,true,true,true};
	    main.add(afegirOpcions(opcionsNomContracte,opcionTokenContracte,typeContracte), opContractar, 40);
	    
	    
	    //Afegir Opcions protegides segons rol usuari
	    if((credential.getRol()==UsuariRol.administrador)||(credential.getRol()==UsuariRol.tresorer))
	    {	
		    // Afegir Grup d'opcions REMESA
		    Widget opRemesa = crearGrupOpcions("Remesa");
		    String[] opcionsNomRemesa  = {"Manteniment Remeses","Control remeses","Rebuts remesa"};
		    String[] opcionTokenRemesa = {AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP,AppToken.TKN_UNDER_DEVELOP};
		    boolean[] typeReme ={false,true,true};
		    main.add(afegirOpcions(opcionsNomRemesa,opcionTokenRemesa,typeReme), opRemesa, 40);
		    
		    //nomes administrado pot gestionar usuaris.
		    if((credential.getRol()==UsuariRol.administrador))
		    {	
		    // Afegir Grup d'opcions CONFIGURACIO
		    Widget opConfig = crearGrupOpcions("Configuració");
		    String[] opcionsNomConfig = {"Manteniment Curs","Manteniment Grups","Manteniment Usuaris","Dades Associació"};
		    String[] opcionTokenConfig = {AppToken.TKN_MNT_CURS,AppToken.TKN_MNT_GRUP,AppToken.TKN_MNT_USUARI,AppToken.TKN_MNT_ASSOC_EDIT};
		    boolean[] typeConfig ={false,false,false,false};
		    main.add(afegirOpcions(opcionsNomConfig,opcionTokenConfig,typeConfig), opConfig, 40);
		    }
	    }
	    root.add(main);
	}
	
	
	  private Widget crearGrupOpcions(String text) 
	  {
		  
		    HorizontalPanel hPanel = new HorizontalPanel();
		    hPanel.setHeight("100%");
		    hPanel.setSpacing(0);
		    hPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		   // hPanel.add(new Image(image));
		    HTML headerText = new HTML(text);
		    headerText.setStyleName("cw-StackPanelHeader");
		    hPanel.add(headerText);
		    return new SimplePanel(hPanel);
	  }
	  
	  private Widget afegirOpcions(String[] opcioNom,String[] opcioToken,boolean[] isreport) 
	  {
		    VerticalPanel opcionsGrup = new VerticalPanel();
		    opcionsGrup.setSpacing(4);

		    for (int i = 0; i < opcioNom.length; i++) 
		    {
		      String nom = opcioNom[i];
		      String token = opcioToken[i];
		      boolean isReport = isreport[i];
		      
		      Widget opcio = genMenuEntry(nom,token,isReport);
		      opcionsGrup.add(opcio);
		    }
		    
		    return new SimplePanel(opcionsGrup);
	   }
	
	  private Widget genMenuEntry(String nom,String token,boolean isReport)
	  {
		  HorizontalPanel entry = new HorizontalPanel();
		  Image iconaOpcio ;
		  
		  if(isReport) iconaOpcio=new Image(resources.reportImage());
		  else iconaOpcio=new Image(resources.formImage());
		  
		  iconaOpcio.getElement().getStyle().setMarginRight(5, Unit.PX);
		  entry.add(iconaOpcio);
		  entry.add(new Hyperlink(nom,token));
		  
		  return entry;
	  }
}
