package org.mut.ampa.client.widget.selectBox;

import java.util.List;
import java.util.Map;

import org.mut.ampa.shared.ListBoxTransformable;

import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlexTable.FlexCellFormatter;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.LayoutPanel;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * Component per a cercar de forma general
 * Permet afegir una entitat de les trobades.
 * @author Mario Unio UOC 2012
 *
 * @param <T>
 */
public  class SelectBox<T extends ListBoxTransformable> extends DialogBox{

	//valors que s'han obtingut al relitzar la cerca
	private List<T> trobats;
	public List<T> getTrobats() {return trobats;}
	public void setTrobats(List<T> trobats) {
		this.trobats = trobats;
		conjuntcerca.clear();
		for (T t : trobats) {
			conjuntcerca.addItem(t.transform());	
		}
	}
		public int getSelected() {return conjuntcerca.getSelectedIndex();}
	
	private final VerticalPanel root = new VerticalPanel();
	private final FlexTable filters  ; 
	private final ListBox  conjuntcerca = new ListBox();
	LayoutPanel searchBar = new LayoutPanel();
	private final Button search = new Button("Cercar");
	LayoutPanel barraBotons = new LayoutPanel();
	private final Button acceptar = new Button("Acceptar");
	private final Button cancelar = new Button("Cancel·lar");
	
	public SelectBox(String title,Map<Integer,String> filterFields)
	{
		super(false,true);
		setText(title);
		
		//Crear tants camps com elements te el map		
		filters = genFilterFields(filterFields);
		root.add(filters);
		
		//Afegir boto Cercar
		
		searchBar.add(search);
		searchBar.setWidgetLeftRight(search, 30, Unit.PCT, 30, Unit.PCT);
		searchBar.setWidgetTopBottom(search, 5, Unit.PX, 5, Unit.PX);
		
		searchBar.setWidth("100%");
		searchBar.setHeight("40px");
		root.add(searchBar);
		root.add(conjuntcerca);
		conjuntcerca.setHeight("60px");
		conjuntcerca.setWidth("100%");
		conjuntcerca.setVisibleItemCount(5);
		root.add(barraBotons);
		
		barraBotons.setWidth("100%");
		barraBotons.setHeight("40px");
		barraBotons.add(acceptar);
		barraBotons.setWidgetLeftWidth(acceptar, 10, Unit.PCT, 80, Unit.PX);
		barraBotons.setWidgetTopBottom(acceptar, 5, Unit.PX, 5, Unit.PX);
		barraBotons.add(cancelar);	
		barraBotons.setWidgetRightWidth(cancelar, 10, Unit.PCT, 80, Unit.PX);
		barraBotons.setWidgetTopBottom(cancelar, 5, Unit.PX, 5, Unit.PX);

		//afegim el contingut al DialogBox
		setWidget(root);
		
		SelectBox.this.setGlassEnabled(true);
		SelectBox.this.setAnimationEnabled(true);
		SelectBox.this.center();
	}
	
	
	// Per cada objecte del map afegeix un textbox pel filtratge.
	private FlexTable genFilterFields(Map<Integer,String> filterFields)
	{
		FlexTable container = new FlexTable();
		
		container.setCellSpacing(6);
		FlexCellFormatter cellFormatter = container.getFlexCellFormatter();
	   
		cellFormatter.setColSpan(0, 0, 2);
		cellFormatter.setHorizontalAlignment(0, 0, HasHorizontalAlignment.ALIGN_CENTER);

		int size = filterFields.keySet().size();
		int i=1;
		for (int j=0;j<size;j++) 
		{
			//etiqueta camp
			container.setHTML(i, 0, filterFields.get(j));
			container.setWidth("250px");
			//textBox la registrem
			TextBox tmp=new  TextBox();
			tmp.setName(filterFields.get(j));
			//Afegim el camp.
			container.setWidget(i, 1, tmp);	
			i++;
			
		}
		
		return container;
	}

	public HasClickHandlers getAddButton() {
		return search;
	}

	public HasClickHandlers getSelectButton() {
		
		return acceptar;
	}

	public HasClickHandlers getCancelButton() {
		return cancelar;
	} 
}
