package org.mut.ampa.client.widget.title;

import org.mut.ampa.client.screens.main.view.MainAppResources;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.LayoutPanel;

public class AmpaTitle extends Composite 
{
	private final static String TEXT_SORTIR ="Sortir";
	private final MainAppResources resources =  GWT.create(MainAppResources.class);
	
	private static final LayoutPanel root = new LayoutPanel(); 
	private static final Label 	nomAmpa    = new Label();
	private static final Label 	usuariInfo = new Label();
	private static final Button botoSortir = new Button();
	
	public AmpaTitle() {
	
		
		Image logo = new Image("images/logo.png");
			
		
		initWidget(root);
		root.setHeight("100%");
		root.setWidth("100%");
		
		root.add(logo);
		root.add(nomAmpa);
		root.add(usuariInfo);
		root.add(botoSortir);
		
		logo.setSize("50px","50px");
				
		root.setWidgetLeftWidth(logo, 5, Unit.PX, 50, Unit.PX);
		root.setWidgetTopHeight(logo, 2, Unit.PX, 50, Unit.PX);
		
		root.setWidgetLeftRight(nomAmpa, 100, Unit.PX, 60, Unit.PCT);
		root.setWidgetTopHeight(nomAmpa, 50, Unit.PCT, 20, Unit.PX);
		nomAmpa.setStyleName(resources.style().mainTitleAssociacio());
		
		root.setWidgetRightWidth(usuariInfo, 20, Unit.PX, 250, Unit.PX);
		root.setWidgetTopHeight(usuariInfo, 10, Unit.PX, 20, Unit.PX);
		usuariInfo.setStyleName(resources.style().mainUserText());
		
		root.setWidgetRightWidth(botoSortir, 20, Unit.PX, 80, Unit.PX);
		root.setWidgetTopHeight(botoSortir, 35, Unit.PX, 25, Unit.PX);
		botoSortir.setText(TEXT_SORTIR);
		
	}

	
	public HasClickHandlers getUnLoginButton() {
		return botoSortir;
	}
	
	
	public void setAmpaTitle(String title) {
		nomAmpa.setText(title);
		
	}
	
	
	public void setLogedUserInfo(String userInfo) {
		usuariInfo.setText(userInfo);
		
	}
}
