package org.mut.ampa.shared.utils;

/**
 * Classe per validar els digits d'un numero de Compte Corrent 
 * @author Mario Unio UOC 2012
 *
 */
public class CCValidator 
{
	public static boolean validate(String banc,String oficina,String dc,String numero)
	{
		boolean ret = false;
		
		String calc_dc=calcularDC(banc,oficina,numero);
		if(Integer.valueOf(calc_dc) == Integer.valueOf(dc)) ret =true;

		return ret;
	}
	
	/**
	 * Metode que calcula el digit de control  
	 * @param sBank Codi entitat bancaria
	 * @param sSubBank Codi officina
	 * @param sAccount Numero de Compte
	 * @return El digit de control que correspon als parametres entrats.
	 */
	private static String calcularDC(String sBank, String sSubBank,String sAccount)
	{
		String sBankControlDigit;
		
		//Si les llargades no son correctes sortir.
		if(sBank.length()!=4)    return "-1";
		if(sSubBank.length()!=4) return "-1";
		if(sAccount.length()!=10) return "-1";
		
		int tmp =0;
		tmp=tmp+Integer.valueOf(sBank.substring(0, 1))*4;
		tmp=tmp+Integer.valueOf(sBank.substring(1, 2))*8;
		tmp=tmp+Integer.valueOf(sBank.substring(2, 3))*5;
		tmp=tmp+Integer.valueOf(sBank.substring(3, 4))*10;
		
		tmp=tmp+Integer.valueOf(sSubBank.substring(0, 1))*9;
		tmp=tmp+Integer.valueOf(sSubBank.substring(1, 2))*7;
		tmp=tmp+Integer.valueOf(sSubBank.substring(2, 3))*3;
		tmp=tmp+Integer.valueOf(sSubBank.substring(3, 4))*6;
		tmp = 11 - (tmp %11);
		
		if(tmp == 11) sBankControlDigit="0";
		else if (tmp==10) sBankControlDigit="1";
		else sBankControlDigit=""+tmp;
		
		tmp =0;
		tmp=tmp+Integer.valueOf(sAccount.substring(0, 1))*1;
		tmp=tmp+Integer.valueOf(sAccount.substring(1, 2))*2;
		tmp=tmp+Integer.valueOf(sAccount.substring(2, 3))*4;
		tmp=tmp+Integer.valueOf(sAccount.substring(3, 4))*8;
		tmp=tmp+Integer.valueOf(sAccount.substring(4, 5))*5;
		tmp=tmp+Integer.valueOf(sAccount.substring(5, 6))*10;
		tmp=tmp+Integer.valueOf(sAccount.substring(6, 7))*9;
		tmp=tmp+Integer.valueOf(sAccount.substring(7, 8))*7;
		tmp=tmp+Integer.valueOf(sAccount.substring(8, 9))*3;
		tmp=tmp+Integer.valueOf(sAccount.substring(9, 10))*6;
		tmp = 11 - (tmp %11);
		
		if(tmp == 11) sBankControlDigit=sBankControlDigit+"0";
		else if (tmp==10) sBankControlDigit=sBankControlDigit+"1";
		else sBankControlDigit=sBankControlDigit+tmp;
		
		return sBankControlDigit;
	}
	

}
