-- -----------------------------------------------------
-- SCRIPT CREACIO Base Dades AMPA
-- autor: Mario Unio Torrelles
-- UOC 2012
-- -----------------------------------------------------

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

DROP SCHEMA IF EXISTS `AMPAROSELLA` ;
CREATE SCHEMA IF NOT EXISTS `AMPAROSELLA` DEFAULT CHARACTER SET latin1 COLLATE latin1_spanish_ci ;
USE `AMPAROSELLA` ;

-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ALUMNE`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ALUMNE` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ALUMNE` (
  `id` INT(11) NOT NULL AUTO_INCREMENT ,
  `nom` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom1` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `cognom2` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `data_naix` DATE NULL DEFAULT NULL ,
  `genere` ENUM('H','D') CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL DEFAULT 'H' ,
  `adreca` VARCHAR(150) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `poblacio` VARCHAR(150) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `tsi` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `alergies` VARCHAR(400) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `observacions` VARCHAR(400) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `cc_banc` VARCHAR(4) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `cc_oficina` VARCHAR(4) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `cc_dc` VARCHAR(2) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `cc_num` VARCHAR(10) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `actiu` ENUM('S','N') CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL DEFAULT 'S' ,
  `us_imatge` ENUM('?','N','S') CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL DEFAULT '?' ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ALUMNE_GERMA`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ALUMNE_GERMA` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ALUMNE_GERMA` (
  `idAlumne` INT(11) NOT NULL ,
  `idGerma` INT(11) NOT NULL ,
  `posicio` INT(11) NOT NULL ,
  PRIMARY KEY (`idAlumne`) ,
  INDEX `fk_ALUMNE_GERMA_idx` (`idGerma` ASC) ,
  INDEX `fk_ALUMNE_ALUMNE_idx` (`idAlumne` ASC) ,
  CONSTRAINT `fk_ALUMNE_ALUMNE`
    FOREIGN KEY (`idAlumne` )
    REFERENCES `AMPAROSELLA`.`ALUMNE` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ALUMNE_GERMA`
    FOREIGN KEY (`idGerma` )
    REFERENCES `AMPAROSELLA`.`ALUMNE` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ESPAI`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ESPAI` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ESPAI` (
  `id` INT(11) NOT NULL ,
  `descripcio` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`MONITOR`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`MONITOR` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`MONITOR` (
  `id` INT(11) NOT NULL ,
  `nom` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom1` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom2` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `telefon` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `email` VARCHAR(45) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`TIPUS_SERVEI`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`TIPUS_SERVEI` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`TIPUS_SERVEI` (
  `id` INT(11) NOT NULL ,
  `descripcio` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cobrament` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`SERVEI`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`SERVEI` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`SERVEI` (
  `id` INT(11) NOT NULL ,
  `descripcio` VARCHAR(150) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `preu` DECIMAL(8,2) NOT NULL ,
  `horari` VARCHAR(100) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `dia_servei` ENUM('DILLUMS','DIMARTS','DIMECRES','DIJOUS','DIVENDRES') CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `idEspai` INT(11) NULL DEFAULT NULL ,
  `idMonitor` INT(11) NULL DEFAULT NULL ,
  `idTipusServei` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) ,
  INDEX `fk_SERVEI_ESPAI1_idx` (`idEspai` ASC) ,
  INDEX `fk_SERVEI_MONITOR1_idx` (`idMonitor` ASC) ,
  INDEX `fk_SERVEI_1_idx` (`idTipusServei` ASC) ,
  CONSTRAINT `fk_SERVEI_ESPAI1`
    FOREIGN KEY (`idEspai` )
    REFERENCES `AMPAROSELLA`.`ESPAI` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_SERVEI_MONITOR1`
    FOREIGN KEY (`idMonitor` )
    REFERENCES `AMPAROSELLA`.`MONITOR` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_SERVEI_TIPUS_SERVEI1`
    FOREIGN KEY (`idTipusServei` )
    REFERENCES `AMPAROSELLA`.`TIPUS_SERVEI` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ALUMNE_SERVEI`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ALUMNE_SERVEI` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ALUMNE_SERVEI` (
  `id` INT(11) NOT NULL ,
  `idAlumne` INT(11) NULL DEFAULT NULL ,
  `idServei` INT(11) NULL DEFAULT NULL ,
  `data_inici` DATE NULL DEFAULT NULL ,
  `data_fi` DATE NULL DEFAULT NULL ,
  `dia` INT(11) NULL DEFAULT NULL ,
  `mes` INT(11) NULL DEFAULT NULL ,
  `any` INT(11) NULL DEFAULT NULL ,
  `liquidat` ENUM('S','N') CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT 'N' ,
  `observacions` VARCHAR(150) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `idRemesa` INT(11) NULL DEFAULT NULL ,
  `idRebut` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) ,
  INDEX `fk_ALUMNE_SERVEI1_idx` (`idServei` ASC) ,
  INDEX `fk_ALUMNE_SERVEI_1_idx` (`idAlumne` ASC) ,
  CONSTRAINT `fk_ALUMNE_SERVEI1`
    FOREIGN KEY (`idServei` )
    REFERENCES `AMPAROSELLA`.`SERVEI` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ALUMNE_SERVEI2`
    FOREIGN KEY (`idAlumne` )
    REFERENCES `AMPAROSELLA`.`ALUMNE` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`TUTOR`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`TUTOR` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`TUTOR` (
  `id` INT(11) NOT NULL AUTO_INCREMENT ,
  `nom` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom1` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom2` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `telefon1` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `telefon2` VARCHAR(45) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  `email` VARCHAR(45) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ALUMNE_TUTOR`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ALUMNE_TUTOR` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ALUMNE_TUTOR` (
  `idAlumne` INT(11) NOT NULL ,
  `idTutor` INT(11) NOT NULL ,
  PRIMARY KEY (`idAlumne`) ,
  INDEX `fk_ALUMNE_TUTOR_idx` (`idAlumne` ASC) ,
  INDEX `fk_ALUMNE_TUTOR_TUTOR1_idx` (`idTutor` ASC) ,
  CONSTRAINT `fk_ALUMNE_TUTOR`
    FOREIGN KEY (`idAlumne` )
    REFERENCES `AMPAROSELLA`.`ALUMNE` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ALUMNE_TUTOR_TUTOR1`
    FOREIGN KEY (`idTutor` )
    REFERENCES `AMPAROSELLA`.`TUTOR` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`ASSOCIACIO`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`ASSOCIACIO` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`ASSOCIACIO` (
  `id` INT(11) NOT NULL ,
  `nom` VARCHAR(45) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  `nif` VARCHAR(12) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NULL DEFAULT NULL ,
  `adreca` VARCHAR(150) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NULL DEFAULT NULL ,
  `poblacio` VARCHAR(45) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NULL DEFAULT NULL ,
  `cc_banc` VARCHAR(4) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  `cc_oficina` VARCHAR(4) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  `cc_dc` VARCHAR(2) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  `cc_num` VARCHAR(10) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  `sufix` VARCHAR(3) CHARACTER SET 'latin1' COLLATE 'latin1_general_ci' NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_general_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`CURS`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`CURS` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`CURS` (
  `id` INT(11) NOT NULL AUTO_INCREMENT ,
  `descripcio` VARCHAR(20) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `inici` DATE NULL DEFAULT NULL ,
  `fi` DATE NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`GRUP`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`GRUP` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`GRUP` (
  `id` INT(11) NOT NULL AUTO_INCREMENT ,
  `idCurs` INT(11) NOT NULL ,
  `descripcio` VARCHAR(20) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  PRIMARY KEY (`id`, `idCurs`) ,
  INDEX `fk_GRUP_CURS1_idx` (`idCurs` ASC) ,
  CONSTRAINT `fk_GRUP_CURS1`
    FOREIGN KEY (`idCurs` )
    REFERENCES `AMPAROSELLA`.`CURS` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`CURS_GRUP`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`CURS_GRUP` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`CURS_GRUP` (
  `idAlumne` INT(11) NOT NULL ,
  `GRUP_id` INT(11) NOT NULL ,
  `GRUP_idCurs` INT(11) NOT NULL ,
  PRIMARY KEY (`idAlumne`) ,
  INDEX `fk_CURS_GRUP_3_idx` (`idAlumne` ASC) ,
  INDEX `fk_CURS_GRUP_GRUP1_idx` (`GRUP_id` ASC, `GRUP_idCurs` ASC) ,
  CONSTRAINT `fk_CURS_GRUP_3`
    FOREIGN KEY (`idAlumne` )
    REFERENCES `AMPAROSELLA`.`ALUMNE` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_CURS_GRUP_GRUP1`
    FOREIGN KEY (`GRUP_id` , `GRUP_idCurs` )
    REFERENCES `AMPAROSELLA`.`GRUP` (`id` , `idCurs` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`USUARI`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`USUARI` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`USUARI` (
  `id` INT(11) NOT NULL AUTO_INCREMENT ,
  `nomUsuari` VARCHAR(15) NOT NULL ,
  `passwd` VARCHAR(20) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `nom` VARCHAR(50) CHARACTER SET 'latin1' COLLATE 'latin1_spanish_ci' NOT NULL ,
  `cognom1` VARCHAR(50) NOT NULL ,
  `cognom2` VARCHAR(50) NOT NULL ,
  `rol` ENUM('administrador','tresorer','usuari','soci') NOT NULL ,
  PRIMARY KEY (`id`) ,
  UNIQUE INDEX `nomUsuari_UNIQUE` (`nomUsuari` ASC) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`REMESA`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`REMESA` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`REMESA` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `dataEmissio` DATE NOT NULL ,
  `dataCarrec` DATE NOT NULL ,
  `tipus` INT NULL ,
  `concepte` VARCHAR(50) NOT NULL ,
  `numRebuts` INT NULL ,
  `totalImport` DECIMAL(8,2) NULL ,
  `remesaGenerada` ENUM('N','S') NULL DEFAULT 'N' ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;


-- -----------------------------------------------------
-- Table `AMPAROSELLA`.`REBUT`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `AMPAROSELLA`.`REBUT` ;

CREATE  TABLE IF NOT EXISTS `AMPAROSELLA`.`REBUT` (
  `idRemesa` INT NOT NULL ,
  `idRebut` INT NOT NULL ,
  `numLinea` INT NOT NULL ,
  `idAlumneServei` INT(11) NOT NULL ,
  `cc_banc` VARCHAR(4) NULL ,
  `cc_oficina` VARCHAR(4) NULL ,
  `cc_dc` VARCHAR(2) NULL ,
  `cc_num` VARCHAR(10) NULL ,
  `referencia` VARCHAR(12) NULL ,
  `nifOrdenant` VARCHAR(12) NULL ,
  `sufixOrdenant` VARCHAR(3) NULL ,
  `nom` VARCHAR(40) NULL ,
  `concepte` VARCHAR(40) NULL ,
  `import` DECIMAL(8,2) NULL ,
  `retornat` ENUM('S','N') NULL DEFAULT 'N' ,
  `detall` ENUM('S','N') NULL DEFAULT 'N' ,
  INDEX `fk_REBUT_REMESA1_idx` (`idRemesa` ASC) ,
  PRIMARY KEY (`idRemesa`, `idRebut`, `numLinea`) ,
  INDEX `fk_REBUT_ALUMNE_SERVEI1_idx` (`idAlumneServei` ASC) ,
  CONSTRAINT `fk_REBUT_REMESA1`
    FOREIGN KEY (`idRemesa` )
    REFERENCES `AMPAROSELLA`.`REMESA` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_REBUT_ALUMNE_SERVEI1`
    FOREIGN KEY (`idAlumneServei` )
    REFERENCES `AMPAROSELLA`.`ALUMNE_SERVEI` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
DEFAULT CHARACTER SET = latin1
COLLATE = latin1_spanish_ci;



SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
